/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: CardinalityRestriction.java,v 1.1.1.1 2006/01/31 09:13:24 gxie Exp $
 */
package org.eclipse.eodm.owl;

import org.eclipse.eodm.rdfs.RDFSLiteral;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Cardinality Restriction</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>
 * {@link org.eclipse.eodm.owl.CardinalityRestriction#getOWLCardinality <em>OWL Cardinality</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @see org.eclipse.eodm.owl.OWLPackage#getCardinalityRestriction()
 * @model
 * @generated
 */
public interface CardinalityRestriction extends OWLRestriction {
    /**
     * Returns the value of the '<em><b>OWL Cardinality</b></em>'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @return the value of the '<em>OWL Cardinality</em>' reference.
     * @see #setOWLCardinality(RDFSLiteral)
     * @see org.eclipse.eodm.owl.OWLPackage#getCardinalityRestriction_OWLCardinality()
     * @model required="true"
     * @generated
     */
    RDFSLiteral getOWLCardinality();

    /**
     * Sets the value of the '
     * {@link org.eclipse.eodm.owl.CardinalityRestriction#getOWLCardinality <em>OWL Cardinality</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value
     *            the new value of the '<em>OWL Cardinality</em>' reference.
     * @see #getOWLCardinality()
     * @generated
     */
    void setOWLCardinality(RDFSLiteral value);

} // CardinalityRestriction
