/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: Individual.java,v 1.1.1.1 2006/01/31 09:13:24 gxie Exp $
 */
package org.eclipse.eodm.owl;

import org.eclipse.emf.common.util.EList;
import org.eclipse.eodm.rdfs.RDFSResource;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Individual</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>
 * {@link org.eclipse.eodm.owl.Individual#getOWLDifferentFrom <em>OWL Different From</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.Individual#getInvOWLDifferentFrom <em>Inv OWL Different From</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.Individual#getRefByOWLDistinctMembers <em>Ref By OWL Distinct Members</em>}
 * </li>
 * <li>{@link org.eclipse.eodm.owl.Individual#getOWLSameAs <em>OWL Same As</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.Individual#getInvOWLSameAs <em>Inv OWL Same As</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.Individual#getDatatypeSlot <em>Datatype Slot</em>}
 * </li>
 * <li>{@link org.eclipse.eodm.owl.Individual#getObjectSlot <em>Object Slot</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @see org.eclipse.eodm.owl.OWLPackage#getIndividual()
 * @model
 * @generated
 */
public interface Individual extends RDFSResource {
    /**
     * Returns the value of the '<em><b>OWL Different From</b></em>'
     * reference list. The list contents are of type
     * {@link org.eclipse.eodm.owl.Individual}. It is bidirectional and its opposite
     * is '
     * {@link org.eclipse.eodm.owl.Individual#getInvOWLDifferentFrom <em>Inv OWL Different From</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>OWL Different From</em>' reference
     *         list.
     * @see org.eclipse.eodm.owl.OWLPackage#getIndividual_OWLDifferentFrom()
     * @see org.eclipse.eodm.owl.Individual#getInvOWLDifferentFrom
     * @model type="org.eclipse.owl.Individual" opposite="invOWLDifferentFrom"
     * @generated
     */
    EList getOWLDifferentFrom();

    /**
     * Returns the value of the '<em><b>Inv OWL Different From</b></em>'
     * reference list. The list contents are of type
     * {@link org.eclipse.eodm.owl.Individual}. It is bidirectional and its opposite
     * is '
     * {@link org.eclipse.eodm.owl.Individual#getOWLDifferentFrom <em>OWL Different From</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Inv OWL Different From</em>' reference
     *         list.
     * @see org.eclipse.eodm.owl.OWLPackage#getIndividual_InvOWLDifferentFrom()
     * @see org.eclipse.eodm.owl.Individual#getOWLDifferentFrom
     * @model type="org.eclipse.owl.Individual" opposite="OWLDifferentFrom"
     * @generated
     */
    EList getInvOWLDifferentFrom();

    /**
     * Returns the value of the '<em><b>Ref By OWL Distinct Members</b></em>'
     * reference list. The list contents are of type
     * {@link org.eclipse.eodm.owl.OWLAllDifferent}. It is bidirectional and its
     * opposite is '
     * {@link org.eclipse.eodm.owl.OWLAllDifferent#getOWLDistinctMembers <em>OWL Distinct Members</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Ref By OWL Distinct Members</em>'
     *         reference list.
     * @see org.eclipse.eodm.owl.OWLPackage#getIndividual_RefByOWLDistinctMembers()
     * @see org.eclipse.eodm.owl.OWLAllDifferent#getOWLDistinctMembers
     * @model type="org.eclipse.owl.OWLAllDifferent"
     *        opposite="OWLDistinctMembers"
     * @generated
     */
    EList getRefByOWLDistinctMembers();

    /**
     * Returns the value of the '<em><b>OWL Same As</b></em>' reference
     * list. The list contents are of type {@link org.eclipse.eodm.owl.Individual}.
     * It is bidirectional and its opposite is '
     * {@link org.eclipse.eodm.owl.Individual#getInvOWLSameAs <em>Inv OWL Same As</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>OWL Same As</em>' reference list.
     * @see org.eclipse.eodm.owl.OWLPackage#getIndividual_OWLSameAs()
     * @see org.eclipse.eodm.owl.Individual#getInvOWLSameAs
     * @model type="org.eclipse.owl.Individual" opposite="invOWLSameAs"
     * @generated
     */
    EList getOWLSameAs();

    /**
     * Returns the value of the '<em><b>Inv OWL Same As</b></em>' reference
     * list. The list contents are of type {@link org.eclipse.eodm.owl.Individual}.
     * It is bidirectional and its opposite is '
     * {@link org.eclipse.eodm.owl.Individual#getOWLSameAs <em>OWL Same As</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Inv OWL Same As</em>' reference list.
     * @see org.eclipse.eodm.owl.OWLPackage#getIndividual_InvOWLSameAs()
     * @see org.eclipse.eodm.owl.Individual#getOWLSameAs
     * @model type="org.eclipse.owl.Individual" opposite="OWLSameAs"
     * @generated
     */
    EList getInvOWLSameAs();

    /**
     * Returns the value of the '<em><b>Datatype Slot</b></em>' containment
     * reference list. The list contents are of type
     * {@link org.eclipse.eodm.owl.DatatypeSlot}. It is bidirectional and its
     * opposite is '
     * {@link org.eclipse.eodm.owl.DatatypeSlot#getIndividual <em>Individual</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Datatype Slot</em>' containment
     *         reference list.
     * @see org.eclipse.eodm.owl.OWLPackage#getIndividual_DatatypeSlot()
     * @see org.eclipse.eodm.owl.DatatypeSlot#getIndividual
     * @model type="org.eclipse.owl.DatatypeSlot" opposite="Individual"
     *        containment="true"
     * @generated
     */
    EList getDatatypeSlot();

    /**
     * Returns the value of the '<em><b>Object Slot</b></em>' containment
     * reference list. The list contents are of type
     * {@link org.eclipse.eodm.owl.ObjectSlot}. It is bidirectional and its opposite
     * is '{@link org.eclipse.eodm.owl.ObjectSlot#getIndividual <em>Individual</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Object Slot</em>' containment reference
     *         list.
     * @see org.eclipse.eodm.owl.OWLPackage#getIndividual_ObjectSlot()
     * @see org.eclipse.eodm.owl.ObjectSlot#getIndividual
     * @model type="org.eclipse.owl.ObjectSlot" opposite="Individual"
     *        containment="true"
     * @generated
     */
    EList getObjectSlot();

} // Individual
