/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: OWLOntology.java,v 1.1.1.1 2006/01/31 09:13:24 gxie Exp $
 */
package org.eclipse.eodm.owl;

import org.eclipse.emf.common.util.EList;
import org.eclipse.eodm.rdfs.Ontology;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Ontology</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>
 * {@link org.eclipse.eodm.owl.OWLOntology#getOWLBackwardCompatibleWith <em>OWL Backward Compatible With</em>}
 * </li>
 * <li>{@link org.eclipse.eodm.owl.OWLOntology#getOWLImports <em>OWL Imports</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.OWLOntology#getOWLIncompatibleWith <em>OWL Incompatible With</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.OWLOntology#getOWLPriorVersion <em>OWL Prior Version</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.OWLOntology#getOWLVersionInfo <em>OWL Version Info</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @see org.eclipse.eodm.owl.OWLPackage#getOWLOntology()
 * @model
 * @generated
 */
public interface OWLOntology extends Ontology {
    /**
     * Returns the value of the '<em><b>OWL Backward Compatible With</b></em>'
     * reference list. The list contents are of type
     * {@link org.eclipse.eodm.owl.OWLOntology}. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>OWL Backward Compatible With</em>'
     *         reference list.
     * @see org.eclipse.eodm.owl.OWLPackage#getOWLOntology_OWLBackwardCompatibleWith()
     * @model type="org.eclipse.owl.OWLOntology"
     * @generated
     */
    EList getOWLBackwardCompatibleWith();

    /**
     * Returns the value of the '<em><b>OWL Imports</b></em>' reference
     * list. The list contents are of type {@link org.eclipse.eodm.owl.OWLOntology}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>OWL Imports</em>' reference list.
     * @see org.eclipse.eodm.owl.OWLPackage#getOWLOntology_OWLImports()
     * @model type="org.eclipse.owl.OWLOntology"
     * @generated
     */
    EList getOWLImports();

    /**
     * Returns the value of the '<em><b>OWL Incompatible With</b></em>'
     * reference list. The list contents are of type
     * {@link org.eclipse.eodm.owl.OWLOntology}. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>OWL Incompatible With</em>' reference
     *         list.
     * @see org.eclipse.eodm.owl.OWLPackage#getOWLOntology_OWLIncompatibleWith()
     * @model type="org.eclipse.owl.OWLOntology"
     * @generated
     */
    EList getOWLIncompatibleWith();

    /**
     * Returns the value of the '<em><b>OWL Prior Version</b></em>'
     * reference list. The list contents are of type
     * {@link org.eclipse.eodm.owl.OWLOntology}. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>OWL Prior Version</em>' reference list.
     * @see org.eclipse.eodm.owl.OWLPackage#getOWLOntology_OWLPriorVersion()
     * @model type="org.eclipse.owl.OWLOntology"
     * @generated
     */
    EList getOWLPriorVersion();

    /**
     * Returns the value of the '<em><b>OWL Version Info</b></em>'
     * containment reference list. The list contents are of type
     * {@link org.eclipse.eodm.rdfs.RDFSLiteral}. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>OWL Version Info</em>' containment
     *         reference list.
     * @see org.eclipse.eodm.owl.OWLPackage#getOWLOntology_OWLVersionInfo()
     * @model type="org.eclipse.rdfs.RDFSLiteral" containment="true"
     * @generated
     */
    EList getOWLVersionInfo();

} // OWLOntology
