/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: OWLRestriction.java,v 1.1.1.1 2006/01/31 09:13:24 gxie Exp $
 */
package org.eclipse.eodm.owl;

import org.eclipse.eodm.rdfs.RDFProperty;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Restriction</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>
 * {@link org.eclipse.eodm.owl.OWLRestriction#getOWLOnProperty <em>OWL On Property</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @see org.eclipse.eodm.owl.OWLPackage#getOWLRestriction()
 * @model abstract="true"
 * @generated
 */
public interface OWLRestriction extends OWLClass {
    /**
     * Returns the value of the '<em><b>OWL On Property</b></em>'
     * reference. It is bidirectional and its opposite is '
     * {@link org.eclipse.eodm.rdfs.RDFProperty#getRefByRestriction <em>Ref By Restriction</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>OWL On Property</em>' reference.
     * @see #setOWLOnProperty(RDFProperty)
     * @see org.eclipse.eodm.owl.OWLPackage#getOWLRestriction_OWLOnProperty()
     * @see org.eclipse.eodm.rdfs.RDFProperty#getRefByRestriction
     * @model opposite="refByRestriction" required="true"
     * @generated
     */
    RDFProperty getOWLOnProperty();

    /**
     * Sets the value of the '
     * {@link org.eclipse.eodm.owl.OWLRestriction#getOWLOnProperty <em>OWL On Property</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value
     *            the new value of the '<em>OWL On Property</em>' reference.
     * @see #getOWLOnProperty()
     * @generated
     */
    void setOWLOnProperty(RDFProperty value);

} // OWLRestriction
