/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: ObjectSlot.java,v 1.1.1.1 2006/01/31 09:13:24 gxie Exp $
 */
package org.eclipse.eodm.owl;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Object Slot</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link org.eclipse.eodm.owl.ObjectSlot#getIndividual <em>Individual</em>}
 * </li>
 * <li>{@link org.eclipse.eodm.owl.ObjectSlot#getContent <em>Content</em>}</li>
 * <li>{@link org.eclipse.eodm.owl.ObjectSlot#getProperty <em>Property</em>}</li>
 * </ul>
 * </p>
 * 
 * @see org.eclipse.eodm.owl.OWLPackage#getObjectSlot()
 * @model
 * @generated
 */
public interface ObjectSlot extends EObject {
    /**
     * Returns the value of the '<em><b>Individual</b></em>' container
     * reference. It is bidirectional and its opposite is '
     * {@link org.eclipse.eodm.owl.Individual#getObjectSlot <em>Object Slot</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Individual</em>' container reference.
     * @see #setIndividual(Individual)
     * @see org.eclipse.eodm.owl.OWLPackage#getObjectSlot_Individual()
     * @see org.eclipse.eodm.owl.Individual#getObjectSlot
     * @model opposite="objectSlot"
     * @generated
     */
    Individual getIndividual();

    /**
     * Sets the value of the '
     * {@link org.eclipse.eodm.owl.ObjectSlot#getIndividual <em>Individual</em>}'
     * container reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value
     *            the new value of the '<em>Individual</em>' container
     *            reference.
     * @see #getIndividual()
     * @generated
     */
    void setIndividual(Individual value);

    /**
     * Returns the value of the '<em><b>Content</b></em>' reference list.
     * The list contents are of type {@link org.eclipse.eodm.owl.Individual}. 
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Content</em>' reference list.
     * @see org.eclipse.eodm.owl.OWLPackage#getObjectSlot_Content()
     * @model type="org.eclipse.owl.Individual" required="true"
     * @generated
     */
    EList getContent();

    /**
     * Returns the value of the '<em><b>Property</b></em>' reference. 
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Property</em>' reference.
     * @see #setProperty(OWLObjectProperty)
     * @see org.eclipse.eodm.owl.OWLPackage#getObjectSlot_Property()
     * @model required="true"
     * @generated
     */
    OWLObjectProperty getProperty();

    /**
     * Sets the value of the '
     * {@link org.eclipse.eodm.owl.ObjectSlot#getProperty <em>Property</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value
     *            the new value of the '<em>Property</em>' reference.
     * @see #getProperty()
     * @generated
     */
    void setProperty(OWLObjectProperty value);

} // ObjectSlot
