/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: UnionClass.java,v 1.1.1.1 2006/01/31 09:13:24 gxie Exp $
 */
package org.eclipse.eodm.owl;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Union Class</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link org.eclipse.eodm.owl.UnionClass#getOWLUnionOf <em>OWL Union Of</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @see org.eclipse.eodm.owl.OWLPackage#getUnionClass()
 * @model
 * @generated
 */
public interface UnionClass extends OWLClass {
    /**
     * Returns the value of the '<em><b>OWL Union Of</b></em>' reference
     * list. The list contents are of type {@link org.eclipse.eodm.owl.OWLClass}. It
     * is bidirectional and its opposite is '
     * {@link org.eclipse.eodm.owl.OWLClass#getRefByUnionClass <em>Ref By Union Class</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>OWL Union Of</em>' reference list.
     * @see org.eclipse.eodm.owl.OWLPackage#getUnionClass_OWLUnionOf()
     * @see org.eclipse.eodm.owl.OWLClass#getRefByUnionClass
     * @model type="org.eclipse.owl.OWLClass" opposite="refByUnionClass"
     * @generated
     */
    EList getOWLUnionOf();

} // UnionClass
