/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: MinCardinalityRestrictionImpl.java,v 1.1.1.1 2006/01/31 09:13:24 gxie Exp $
 */
package org.eclipse.eodm.owl.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.eodm.owl.MinCardinalityRestriction;
import org.eclipse.eodm.owl.OWLPackage;
import org.eclipse.eodm.rdfs.Namespace;
import org.eclipse.eodm.rdfs.RDFProperty;
import org.eclipse.eodm.rdfs.RDFSLiteral;
import org.eclipse.eodm.rdfs.RDFSPackage;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Min Cardinality Restriction</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.MinCardinalityRestrictionImpl#getOWLMinCardinality <em>OWL Min Cardinality</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class MinCardinalityRestrictionImpl extends OWLRestrictionImpl implements
        MinCardinalityRestriction {
    /**
     * The cached value of the '
     * {@link #getOWLMinCardinality() <em>OWL Min Cardinality</em>}' reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getOWLMinCardinality()
     * @generated
     * @ordered
     */
    protected RDFSLiteral owlMinCardinality = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected MinCardinalityRestrictionImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return OWLPackage.eINSTANCE.getMinCardinalityRestriction();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public RDFSLiteral getOWLMinCardinality() {
        if (owlMinCardinality != null && owlMinCardinality.eIsProxy()) {
            RDFSLiteral oldOWLMinCardinality = owlMinCardinality;
            owlMinCardinality = (RDFSLiteral) eResolveProxy((InternalEObject) owlMinCardinality);
            if (owlMinCardinality != oldOWLMinCardinality) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(
                            this,
                            Notification.RESOLVE,
                            OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_MIN_CARDINALITY,
                            oldOWLMinCardinality, owlMinCardinality));
            }
        }
        return owlMinCardinality;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public RDFSLiteral basicGetOWLMinCardinality() {
        return owlMinCardinality;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setOWLMinCardinality(RDFSLiteral newOWLMinCardinality) {
        RDFSLiteral oldOWLMinCardinality = owlMinCardinality;
        owlMinCardinality = newOWLMinCardinality;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(
                    this,
                    Notification.SET,
                    OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_MIN_CARDINALITY,
                    oldOWLMinCardinality, owlMinCardinality));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd,
            int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__SUBJECT_STATEMENT:
                return ((InternalEList) getSubjectStatement()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__OBJECT_STATEMENT:
                return ((InternalEList) getObjectStatement()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDF_TYPE:
                return ((InternalEList) getRDFType()).basicAdd(otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__PREDICATE_STATEMENT:
                return ((InternalEList) getPredicateStatement()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_AVF_RESTRICTION:
                return ((InternalEList) getRefByAVFRestriction()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_SVF_RESTRICTION:
                return ((InternalEList) getRefBySVFRestriction()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_SUB_CLASS_OF:
                return ((InternalEList) getRDFSSubClassOf()).basicAdd(otherEnd,
                        msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__SUB_CLASS:
                return ((InternalEList) getSubClass()).basicAdd(otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWNED_PROPERTY:
                return ((InternalEList) getOwnedProperty()).basicAdd(otherEnd,
                        msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__RANGED_BY_PROPERTY:
                return ((InternalEList) getRangedByProperty()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__INSTANCE:
                return ((InternalEList) getInstance()).basicAdd(otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__INV_OWL_EQUIVALENT_CLASS:
                return ((InternalEList) getInvOWLEquivalentClass()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_EQUIVALENT_CLASS:
                return ((InternalEList) getOWLEquivalentClass()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_DISJOINT_WITH:
                return ((InternalEList) getOWLDisjointWith()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__INV_OWL_DISJOINT_WITH:
                return ((InternalEList) getInvOWLDisjointWith()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_INTERSECTION_CLASS:
                return ((InternalEList) getRefByIntersectionClass()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_UNION_CLASS:
                return ((InternalEList) getRefByUnionClass()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__INV_OWL_COMPLEMENT_OF:
                return ((InternalEList) getInvOWLComplementOf()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_ON_PROPERTY:
                if (owlOnProperty != null)
                    msgs = ((InternalEObject) owlOnProperty).eInverseRemove(
                            this, RDFSPackage.RDF_PROPERTY__REF_BY_RESTRICTION,
                            RDFProperty.class, msgs);
                return basicSetOWLOnProperty((RDFProperty) otherEnd, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__SUBJECT_STATEMENT:
                return ((InternalEList) getSubjectStatement()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__OBJECT_STATEMENT:
                return ((InternalEList) getObjectStatement()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDF_TYPE:
                return ((InternalEList) getRDFType()).basicRemove(otherEnd,
                        msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__PREDICATE_STATEMENT:
                return ((InternalEList) getPredicateStatement()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_AVF_RESTRICTION:
                return ((InternalEList) getRefByAVFRestriction()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_SVF_RESTRICTION:
                return ((InternalEList) getRefBySVFRestriction()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_SUB_CLASS_OF:
                return ((InternalEList) getRDFSSubClassOf()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__SUB_CLASS:
                return ((InternalEList) getSubClass()).basicRemove(otherEnd,
                        msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWNED_PROPERTY:
                return ((InternalEList) getOwnedProperty()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__RANGED_BY_PROPERTY:
                return ((InternalEList) getRangedByProperty()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__INSTANCE:
                return ((InternalEList) getInstance()).basicRemove(otherEnd,
                        msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__INV_OWL_EQUIVALENT_CLASS:
                return ((InternalEList) getInvOWLEquivalentClass())
                        .basicRemove(otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_EQUIVALENT_CLASS:
                return ((InternalEList) getOWLEquivalentClass()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_DISJOINT_WITH:
                return ((InternalEList) getOWLDisjointWith()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__INV_OWL_DISJOINT_WITH:
                return ((InternalEList) getInvOWLDisjointWith()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_INTERSECTION_CLASS:
                return ((InternalEList) getRefByIntersectionClass())
                        .basicRemove(otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_UNION_CLASS:
                return ((InternalEList) getRefByUnionClass()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__INV_OWL_COMPLEMENT_OF:
                return ((InternalEList) getInvOWLComplementOf()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_ON_PROPERTY:
                return basicSetOWLOnProperty(null, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass,
                        msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__LOCAL_NAME:
            return getLocalName();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__URI:
            return getURI();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__SUBJECT_STATEMENT:
            return getSubjectStatement();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OBJECT_STATEMENT:
            return getObjectStatement();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_IS_DEFINED_BY:
            return getRDFSIsDefinedBy();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDF_VALUE:
            return getRDFValue();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_SEE_ALSO:
            return getRDFSSeeAlso();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDF_TYPE:
            return getRDFType();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_MEMBER:
            return getRDFSMember();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__PREDICATE_STATEMENT:
            return getPredicateStatement();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_COMMENT:
            return getRDFSComment();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_LABEL:
            return getRDFSLabel();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__NAMESPACE:
            if (resolve)
                return getNamespace();
            return basicGetNamespace();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_AVF_RESTRICTION:
            return getRefByAVFRestriction();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_SVF_RESTRICTION:
            return getRefBySVFRestriction();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_SUB_CLASS_OF:
            return getRDFSSubClassOf();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__SUB_CLASS:
            return getSubClass();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWNED_PROPERTY:
            return getOwnedProperty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RANGED_BY_PROPERTY:
            return getRangedByProperty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__INSTANCE:
            return getInstance();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__DEPRECATED:
            return getDeprecated();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__INV_OWL_EQUIVALENT_CLASS:
            return getInvOWLEquivalentClass();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_EQUIVALENT_CLASS:
            return getOWLEquivalentClass();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_DISJOINT_WITH:
            return getOWLDisjointWith();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__INV_OWL_DISJOINT_WITH:
            return getInvOWLDisjointWith();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_INTERSECTION_CLASS:
            return getRefByIntersectionClass();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_UNION_CLASS:
            return getRefByUnionClass();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__INV_OWL_COMPLEMENT_OF:
            return getInvOWLComplementOf();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_ON_PROPERTY:
            if (resolve)
                return getOWLOnProperty();
            return basicGetOWLOnProperty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_MIN_CARDINALITY:
            if (resolve)
                return getOWLMinCardinality();
            return basicGetOWLMinCardinality();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__LOCAL_NAME:
            setLocalName((String) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__SUBJECT_STATEMENT:
            getSubjectStatement().clear();
            getSubjectStatement().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OBJECT_STATEMENT:
            getObjectStatement().clear();
            getObjectStatement().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_IS_DEFINED_BY:
            getRDFSIsDefinedBy().clear();
            getRDFSIsDefinedBy().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDF_VALUE:
            getRDFValue().clear();
            getRDFValue().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_SEE_ALSO:
            getRDFSSeeAlso().clear();
            getRDFSSeeAlso().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDF_TYPE:
            getRDFType().clear();
            getRDFType().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_MEMBER:
            getRDFSMember().clear();
            getRDFSMember().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__PREDICATE_STATEMENT:
            getPredicateStatement().clear();
            getPredicateStatement().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_COMMENT:
            getRDFSComment().clear();
            getRDFSComment().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_LABEL:
            getRDFSLabel().clear();
            getRDFSLabel().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__NAMESPACE:
            setNamespace((Namespace) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_AVF_RESTRICTION:
            getRefByAVFRestriction().clear();
            getRefByAVFRestriction().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_SVF_RESTRICTION:
            getRefBySVFRestriction().clear();
            getRefBySVFRestriction().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_SUB_CLASS_OF:
            getRDFSSubClassOf().clear();
            getRDFSSubClassOf().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__SUB_CLASS:
            getSubClass().clear();
            getSubClass().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWNED_PROPERTY:
            getOwnedProperty().clear();
            getOwnedProperty().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RANGED_BY_PROPERTY:
            getRangedByProperty().clear();
            getRangedByProperty().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__INSTANCE:
            getInstance().clear();
            getInstance().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__DEPRECATED:
            setDeprecated((Boolean) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__INV_OWL_EQUIVALENT_CLASS:
            getInvOWLEquivalentClass().clear();
            getInvOWLEquivalentClass().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_EQUIVALENT_CLASS:
            getOWLEquivalentClass().clear();
            getOWLEquivalentClass().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_DISJOINT_WITH:
            getOWLDisjointWith().clear();
            getOWLDisjointWith().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__INV_OWL_DISJOINT_WITH:
            getInvOWLDisjointWith().clear();
            getInvOWLDisjointWith().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_INTERSECTION_CLASS:
            getRefByIntersectionClass().clear();
            getRefByIntersectionClass().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_UNION_CLASS:
            getRefByUnionClass().clear();
            getRefByUnionClass().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__INV_OWL_COMPLEMENT_OF:
            getInvOWLComplementOf().clear();
            getInvOWLComplementOf().addAll((Collection) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_ON_PROPERTY:
            setOWLOnProperty((RDFProperty) newValue);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_MIN_CARDINALITY:
            setOWLMinCardinality((RDFSLiteral) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__LOCAL_NAME:
            setLocalName(LOCAL_NAME_EDEFAULT);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__SUBJECT_STATEMENT:
            getSubjectStatement().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OBJECT_STATEMENT:
            getObjectStatement().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_IS_DEFINED_BY:
            getRDFSIsDefinedBy().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDF_VALUE:
            getRDFValue().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_SEE_ALSO:
            getRDFSSeeAlso().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDF_TYPE:
            getRDFType().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_MEMBER:
            getRDFSMember().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__PREDICATE_STATEMENT:
            getPredicateStatement().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_COMMENT:
            getRDFSComment().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_LABEL:
            getRDFSLabel().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__NAMESPACE:
            setNamespace((Namespace) null);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_AVF_RESTRICTION:
            getRefByAVFRestriction().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_SVF_RESTRICTION:
            getRefBySVFRestriction().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_SUB_CLASS_OF:
            getRDFSSubClassOf().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__SUB_CLASS:
            getSubClass().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWNED_PROPERTY:
            getOwnedProperty().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RANGED_BY_PROPERTY:
            getRangedByProperty().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__INSTANCE:
            getInstance().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__DEPRECATED:
            setDeprecated(DEPRECATED_EDEFAULT);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__INV_OWL_EQUIVALENT_CLASS:
            getInvOWLEquivalentClass().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_EQUIVALENT_CLASS:
            getOWLEquivalentClass().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_DISJOINT_WITH:
            getOWLDisjointWith().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__INV_OWL_DISJOINT_WITH:
            getInvOWLDisjointWith().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_INTERSECTION_CLASS:
            getRefByIntersectionClass().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_UNION_CLASS:
            getRefByUnionClass().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__INV_OWL_COMPLEMENT_OF:
            getInvOWLComplementOf().clear();
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_ON_PROPERTY:
            setOWLOnProperty((RDFProperty) null);
            return;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_MIN_CARDINALITY:
            setOWLMinCardinality((RDFSLiteral) null);
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__LOCAL_NAME:
            return LOCAL_NAME_EDEFAULT == null ? localName != null
                    : !LOCAL_NAME_EDEFAULT.equals(localName);
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__URI:
            return URI_EDEFAULT == null ? getURI() != null : !URI_EDEFAULT
                    .equals(getURI());
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__SUBJECT_STATEMENT:
            return subjectStatement != null && !subjectStatement.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OBJECT_STATEMENT:
            return objectStatement != null && !objectStatement.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_IS_DEFINED_BY:
            return rdfsIsDefinedBy != null && !rdfsIsDefinedBy.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDF_VALUE:
            return rdfValue != null && !rdfValue.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_SEE_ALSO:
            return rdfsSeeAlso != null && !rdfsSeeAlso.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDF_TYPE:
            return rdfType != null && !rdfType.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_MEMBER:
            return rdfsMember != null && !rdfsMember.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__PREDICATE_STATEMENT:
            return predicateStatement != null && !predicateStatement.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_COMMENT:
            return rdfsComment != null && !rdfsComment.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_LABEL:
            return rdfsLabel != null && !rdfsLabel.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__NAMESPACE:
            return namespace != null;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_AVF_RESTRICTION:
            return refByAVFRestriction != null
                   && !refByAVFRestriction.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_SVF_RESTRICTION:
            return refBySVFRestriction != null
                   && !refBySVFRestriction.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RDFS_SUB_CLASS_OF:
            return rdfsSubClassOf != null && !rdfsSubClassOf.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__SUB_CLASS:
            return subClass != null && !subClass.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWNED_PROPERTY:
            return ownedProperty != null && !ownedProperty.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__RANGED_BY_PROPERTY:
            return rangedByProperty != null && !rangedByProperty.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__INSTANCE:
            return instance != null && !instance.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__DEPRECATED:
            return DEPRECATED_EDEFAULT == null ? deprecated != null
                    : !DEPRECATED_EDEFAULT.equals(deprecated);
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__INV_OWL_EQUIVALENT_CLASS:
            return invOWLEquivalentClass != null
                   && !invOWLEquivalentClass.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_EQUIVALENT_CLASS:
            return owlEquivalentClass != null && !owlEquivalentClass.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_DISJOINT_WITH:
            return owlDisjointWith != null && !owlDisjointWith.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__INV_OWL_DISJOINT_WITH:
            return invOWLDisjointWith != null && !invOWLDisjointWith.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_INTERSECTION_CLASS:
            return refByIntersectionClass != null
                   && !refByIntersectionClass.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__REF_BY_UNION_CLASS:
            return refByUnionClass != null && !refByUnionClass.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__INV_OWL_COMPLEMENT_OF:
            return invOWLComplementOf != null && !invOWLComplementOf.isEmpty();
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_ON_PROPERTY:
            return owlOnProperty != null;
        case OWLPackage.MIN_CARDINALITY_RESTRICTION__OWL_MIN_CARDINALITY:
            return owlMinCardinality != null;
        }
        return eDynamicIsSet(eFeature);
    }

} //MinCardinalityRestrictionImpl
