/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: OWLObjectPropertyImpl.java,v 1.1.1.1 2006/01/31 09:13:24 gxie Exp $
 */
package org.eclipse.eodm.owl.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.eodm.owl.OWLObjectProperty;
import org.eclipse.eodm.owl.OWLPackage;
import org.eclipse.eodm.rdfs.Namespace;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Object Property</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.OWLObjectPropertyImpl#getInverseFunctional <em>Inverse Functional</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.OWLObjectPropertyImpl#getSymmetric <em>Symmetric</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.OWLObjectPropertyImpl#getTransitive <em>Transitive</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.OWLObjectPropertyImpl#getOWLInverseOf <em>OWL Inverse Of</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.OWLObjectPropertyImpl#getInvOWLInverseOf <em>Inv OWL Inverse Of</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class OWLObjectPropertyImpl extends PropertyImpl implements
        OWLObjectProperty {
    /**
     * The default value of the '
     * {@link #getInverseFunctional() <em>Inverse Functional</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getInverseFunctional()
     * @generated
     * @ordered
     */
    protected static final Boolean INVERSE_FUNCTIONAL_EDEFAULT = null;

    /**
     * The cached value of the '
     * {@link #getInverseFunctional() <em>Inverse Functional</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getInverseFunctional()
     * @generated
     * @ordered
     */
    protected Boolean inverseFunctional = INVERSE_FUNCTIONAL_EDEFAULT;

    /**
     * The default value of the '{@link #getSymmetric() <em>Symmetric</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getSymmetric()
     * @generated
     * @ordered
     */
    protected static final Boolean SYMMETRIC_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getSymmetric() <em>Symmetric</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getSymmetric()
     * @generated
     * @ordered
     */
    protected Boolean symmetric = SYMMETRIC_EDEFAULT;

    /**
     * The default value of the '{@link #getTransitive() <em>Transitive</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getTransitive()
     * @generated
     * @ordered
     */
    protected static final Boolean TRANSITIVE_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getTransitive() <em>Transitive</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getTransitive()
     * @generated
     * @ordered
     */
    protected Boolean transitive = TRANSITIVE_EDEFAULT;

    /**
     * The cached value of the '
     * {@link #getOWLInverseOf() <em>OWL Inverse Of</em>}' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getOWLInverseOf()
     * @generated
     * @ordered
     */
    protected OWLObjectProperty owlInverseOf = null;

    /**
     * The cached value of the '
     * {@link #getInvOWLInverseOf() <em>Inv OWL Inverse Of</em>}' reference
     * list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getInvOWLInverseOf()
     * @generated
     * @ordered
     */
    protected EList invOWLInverseOf = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected OWLObjectPropertyImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return OWLPackage.eINSTANCE.getOWLObjectProperty();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Boolean getInverseFunctional() {
        return inverseFunctional;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setInverseFunctional(Boolean newInverseFunctional) {
        Boolean oldInverseFunctional = inverseFunctional;
        inverseFunctional = newInverseFunctional;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    OWLPackage.OWL_OBJECT_PROPERTY__INVERSE_FUNCTIONAL,
                    oldInverseFunctional, inverseFunctional));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Boolean getSymmetric() {
        return symmetric;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSymmetric(Boolean newSymmetric) {
        Boolean oldSymmetric = symmetric;
        symmetric = newSymmetric;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    OWLPackage.OWL_OBJECT_PROPERTY__SYMMETRIC, oldSymmetric,
                    symmetric));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Boolean getTransitive() {
        return transitive;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setTransitive(Boolean newTransitive) {
        Boolean oldTransitive = transitive;
        transitive = newTransitive;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    OWLPackage.OWL_OBJECT_PROPERTY__TRANSITIVE, oldTransitive,
                    transitive));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public OWLObjectProperty getOWLInverseOf() {
        if (owlInverseOf != null && owlInverseOf.eIsProxy()) {
            OWLObjectProperty oldOWLInverseOf = owlInverseOf;
            owlInverseOf = (OWLObjectProperty) eResolveProxy((InternalEObject) owlInverseOf);
            if (owlInverseOf != oldOWLInverseOf) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE,
                            OWLPackage.OWL_OBJECT_PROPERTY__OWL_INVERSE_OF,
                            oldOWLInverseOf, owlInverseOf));
            }
        }
        return owlInverseOf;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public OWLObjectProperty basicGetOWLInverseOf() {
        return owlInverseOf;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetOWLInverseOf(
            OWLObjectProperty newOWLInverseOf, NotificationChain msgs) {
        OWLObjectProperty oldOWLInverseOf = owlInverseOf;
        owlInverseOf = newOWLInverseOf;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this,
                    Notification.SET,
                    OWLPackage.OWL_OBJECT_PROPERTY__OWL_INVERSE_OF,
                    oldOWLInverseOf, newOWLInverseOf);
            if (msgs == null)
                msgs = notification;
            else
                msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setOWLInverseOf(OWLObjectProperty newOWLInverseOf) {
        if (newOWLInverseOf != owlInverseOf) {
            NotificationChain msgs = null;
            if (owlInverseOf != null)
                msgs = ((InternalEObject) owlInverseOf).eInverseRemove(this,
                        OWLPackage.OWL_OBJECT_PROPERTY__INV_OWL_INVERSE_OF,
                        OWLObjectProperty.class, msgs);
            if (newOWLInverseOf != null)
                msgs = ((InternalEObject) newOWLInverseOf).eInverseAdd(this,
                        OWLPackage.OWL_OBJECT_PROPERTY__INV_OWL_INVERSE_OF,
                        OWLObjectProperty.class, msgs);
            msgs = basicSetOWLInverseOf(newOWLInverseOf, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    OWLPackage.OWL_OBJECT_PROPERTY__OWL_INVERSE_OF,
                    newOWLInverseOf, newOWLInverseOf));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList getInvOWLInverseOf() {
        if (invOWLInverseOf == null) {
            invOWLInverseOf = new EObjectWithInverseResolvingEList(
                    OWLObjectProperty.class, this,
                    OWLPackage.OWL_OBJECT_PROPERTY__INV_OWL_INVERSE_OF,
                    OWLPackage.OWL_OBJECT_PROPERTY__OWL_INVERSE_OF);
        }
        return invOWLInverseOf;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd,
            int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case OWLPackage.OWL_OBJECT_PROPERTY__SUBJECT_STATEMENT:
                return ((InternalEList) getSubjectStatement()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__OBJECT_STATEMENT:
                return ((InternalEList) getObjectStatement()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__RDF_TYPE:
                return ((InternalEList) getRDFType()).basicAdd(otherEnd, msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__PREDICATE_STATEMENT:
                return ((InternalEList) getPredicateStatement()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__REF_BY_RESTRICTION:
                return ((InternalEList) getRefByRestriction()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_SUB_PROPERTY_OF:
                return ((InternalEList) getRDFSSubPropertyOf()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__SUB_PROPERTY:
                return ((InternalEList) getSubProperty()).basicAdd(otherEnd,
                        msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_DOMAIN:
                return ((InternalEList) getRDFSDomain()).basicAdd(otherEnd,
                        msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_RANGE:
                return ((InternalEList) getRDFSRange())
                        .basicAdd(otherEnd, msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__OWL_EQUIVALENT_PROPERTY:
                return ((InternalEList) getOWLEquivalentProperty()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__INV_OWL_EQUIVALENT_PROPERTY:
                return ((InternalEList) getInvOWLEquivalentProperty())
                        .basicAdd(otherEnd, msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__OWL_INVERSE_OF:
                if (owlInverseOf != null)
                    msgs = ((InternalEObject) owlInverseOf).eInverseRemove(
                            this,
                            OWLPackage.OWL_OBJECT_PROPERTY__INV_OWL_INVERSE_OF,
                            OWLObjectProperty.class, msgs);
                return basicSetOWLInverseOf((OWLObjectProperty) otherEnd, msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__INV_OWL_INVERSE_OF:
                return ((InternalEList) getInvOWLInverseOf()).basicAdd(
                        otherEnd, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case OWLPackage.OWL_OBJECT_PROPERTY__SUBJECT_STATEMENT:
                return ((InternalEList) getSubjectStatement()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__OBJECT_STATEMENT:
                return ((InternalEList) getObjectStatement()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__RDF_TYPE:
                return ((InternalEList) getRDFType()).basicRemove(otherEnd,
                        msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__PREDICATE_STATEMENT:
                return ((InternalEList) getPredicateStatement()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__REF_BY_RESTRICTION:
                return ((InternalEList) getRefByRestriction()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_SUB_PROPERTY_OF:
                return ((InternalEList) getRDFSSubPropertyOf()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__SUB_PROPERTY:
                return ((InternalEList) getSubProperty()).basicRemove(otherEnd,
                        msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_DOMAIN:
                return ((InternalEList) getRDFSDomain()).basicRemove(otherEnd,
                        msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_RANGE:
                return ((InternalEList) getRDFSRange()).basicRemove(otherEnd,
                        msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__OWL_EQUIVALENT_PROPERTY:
                return ((InternalEList) getOWLEquivalentProperty())
                        .basicRemove(otherEnd, msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__INV_OWL_EQUIVALENT_PROPERTY:
                return ((InternalEList) getInvOWLEquivalentProperty())
                        .basicRemove(otherEnd, msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__OWL_INVERSE_OF:
                return basicSetOWLInverseOf(null, msgs);
            case OWLPackage.OWL_OBJECT_PROPERTY__INV_OWL_INVERSE_OF:
                return ((InternalEList) getInvOWLInverseOf()).basicRemove(
                        otherEnd, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass,
                        msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.OWL_OBJECT_PROPERTY__LOCAL_NAME:
            return getLocalName();
        case OWLPackage.OWL_OBJECT_PROPERTY__URI:
            return getURI();
        case OWLPackage.OWL_OBJECT_PROPERTY__SUBJECT_STATEMENT:
            return getSubjectStatement();
        case OWLPackage.OWL_OBJECT_PROPERTY__OBJECT_STATEMENT:
            return getObjectStatement();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_IS_DEFINED_BY:
            return getRDFSIsDefinedBy();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDF_VALUE:
            return getRDFValue();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_SEE_ALSO:
            return getRDFSSeeAlso();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDF_TYPE:
            return getRDFType();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_MEMBER:
            return getRDFSMember();
        case OWLPackage.OWL_OBJECT_PROPERTY__PREDICATE_STATEMENT:
            return getPredicateStatement();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_COMMENT:
            return getRDFSComment();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_LABEL:
            return getRDFSLabel();
        case OWLPackage.OWL_OBJECT_PROPERTY__NAMESPACE:
            if (resolve)
                return getNamespace();
            return basicGetNamespace();
        case OWLPackage.OWL_OBJECT_PROPERTY__REF_BY_RESTRICTION:
            return getRefByRestriction();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_SUB_PROPERTY_OF:
            return getRDFSSubPropertyOf();
        case OWLPackage.OWL_OBJECT_PROPERTY__SUB_PROPERTY:
            return getSubProperty();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_DOMAIN:
            return getRDFSDomain();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_RANGE:
            return getRDFSRange();
        case OWLPackage.OWL_OBJECT_PROPERTY__DEPRECATED:
            return getDeprecated();
        case OWLPackage.OWL_OBJECT_PROPERTY__FUNCTIONAL:
            return getFunctional();
        case OWLPackage.OWL_OBJECT_PROPERTY__OWL_EQUIVALENT_PROPERTY:
            return getOWLEquivalentProperty();
        case OWLPackage.OWL_OBJECT_PROPERTY__INV_OWL_EQUIVALENT_PROPERTY:
            return getInvOWLEquivalentProperty();
        case OWLPackage.OWL_OBJECT_PROPERTY__INVERSE_FUNCTIONAL:
            return getInverseFunctional();
        case OWLPackage.OWL_OBJECT_PROPERTY__SYMMETRIC:
            return getSymmetric();
        case OWLPackage.OWL_OBJECT_PROPERTY__TRANSITIVE:
            return getTransitive();
        case OWLPackage.OWL_OBJECT_PROPERTY__OWL_INVERSE_OF:
            if (resolve)
                return getOWLInverseOf();
            return basicGetOWLInverseOf();
        case OWLPackage.OWL_OBJECT_PROPERTY__INV_OWL_INVERSE_OF:
            return getInvOWLInverseOf();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.OWL_OBJECT_PROPERTY__LOCAL_NAME:
            setLocalName((String) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__SUBJECT_STATEMENT:
            getSubjectStatement().clear();
            getSubjectStatement().addAll((Collection) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__OBJECT_STATEMENT:
            getObjectStatement().clear();
            getObjectStatement().addAll((Collection) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_IS_DEFINED_BY:
            getRDFSIsDefinedBy().clear();
            getRDFSIsDefinedBy().addAll((Collection) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDF_VALUE:
            getRDFValue().clear();
            getRDFValue().addAll((Collection) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_SEE_ALSO:
            getRDFSSeeAlso().clear();
            getRDFSSeeAlso().addAll((Collection) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDF_TYPE:
            getRDFType().clear();
            getRDFType().addAll((Collection) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_MEMBER:
            getRDFSMember().clear();
            getRDFSMember().addAll((Collection) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__PREDICATE_STATEMENT:
            getPredicateStatement().clear();
            getPredicateStatement().addAll((Collection) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_COMMENT:
            getRDFSComment().clear();
            getRDFSComment().addAll((Collection) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_LABEL:
            getRDFSLabel().clear();
            getRDFSLabel().addAll((Collection) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__NAMESPACE:
            setNamespace((Namespace) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__REF_BY_RESTRICTION:
            getRefByRestriction().clear();
            getRefByRestriction().addAll((Collection) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_SUB_PROPERTY_OF:
            getRDFSSubPropertyOf().clear();
            getRDFSSubPropertyOf().addAll((Collection) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__SUB_PROPERTY:
            getSubProperty().clear();
            getSubProperty().addAll((Collection) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_DOMAIN:
            getRDFSDomain().clear();
            getRDFSDomain().addAll((Collection) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_RANGE:
            getRDFSRange().clear();
            getRDFSRange().addAll((Collection) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__DEPRECATED:
            setDeprecated((Boolean) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__FUNCTIONAL:
            setFunctional((Boolean) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__OWL_EQUIVALENT_PROPERTY:
            getOWLEquivalentProperty().clear();
            getOWLEquivalentProperty().addAll((Collection) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__INV_OWL_EQUIVALENT_PROPERTY:
            getInvOWLEquivalentProperty().clear();
            getInvOWLEquivalentProperty().addAll((Collection) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__INVERSE_FUNCTIONAL:
            setInverseFunctional((Boolean) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__SYMMETRIC:
            setSymmetric((Boolean) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__TRANSITIVE:
            setTransitive((Boolean) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__OWL_INVERSE_OF:
            setOWLInverseOf((OWLObjectProperty) newValue);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__INV_OWL_INVERSE_OF:
            getInvOWLInverseOf().clear();
            getInvOWLInverseOf().addAll((Collection) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.OWL_OBJECT_PROPERTY__LOCAL_NAME:
            setLocalName(LOCAL_NAME_EDEFAULT);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__SUBJECT_STATEMENT:
            getSubjectStatement().clear();
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__OBJECT_STATEMENT:
            getObjectStatement().clear();
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_IS_DEFINED_BY:
            getRDFSIsDefinedBy().clear();
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDF_VALUE:
            getRDFValue().clear();
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_SEE_ALSO:
            getRDFSSeeAlso().clear();
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDF_TYPE:
            getRDFType().clear();
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_MEMBER:
            getRDFSMember().clear();
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__PREDICATE_STATEMENT:
            getPredicateStatement().clear();
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_COMMENT:
            getRDFSComment().clear();
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_LABEL:
            getRDFSLabel().clear();
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__NAMESPACE:
            setNamespace((Namespace) null);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__REF_BY_RESTRICTION:
            getRefByRestriction().clear();
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_SUB_PROPERTY_OF:
            getRDFSSubPropertyOf().clear();
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__SUB_PROPERTY:
            getSubProperty().clear();
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_DOMAIN:
            getRDFSDomain().clear();
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_RANGE:
            getRDFSRange().clear();
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__DEPRECATED:
            setDeprecated(DEPRECATED_EDEFAULT);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__FUNCTIONAL:
            setFunctional(FUNCTIONAL_EDEFAULT);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__OWL_EQUIVALENT_PROPERTY:
            getOWLEquivalentProperty().clear();
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__INV_OWL_EQUIVALENT_PROPERTY:
            getInvOWLEquivalentProperty().clear();
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__INVERSE_FUNCTIONAL:
            setInverseFunctional(INVERSE_FUNCTIONAL_EDEFAULT);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__SYMMETRIC:
            setSymmetric(SYMMETRIC_EDEFAULT);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__TRANSITIVE:
            setTransitive(TRANSITIVE_EDEFAULT);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__OWL_INVERSE_OF:
            setOWLInverseOf((OWLObjectProperty) null);
            return;
        case OWLPackage.OWL_OBJECT_PROPERTY__INV_OWL_INVERSE_OF:
            getInvOWLInverseOf().clear();
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.OWL_OBJECT_PROPERTY__LOCAL_NAME:
            return LOCAL_NAME_EDEFAULT == null ? localName != null
                    : !LOCAL_NAME_EDEFAULT.equals(localName);
        case OWLPackage.OWL_OBJECT_PROPERTY__URI:
            return URI_EDEFAULT == null ? getURI() != null : !URI_EDEFAULT
                    .equals(getURI());
        case OWLPackage.OWL_OBJECT_PROPERTY__SUBJECT_STATEMENT:
            return subjectStatement != null && !subjectStatement.isEmpty();
        case OWLPackage.OWL_OBJECT_PROPERTY__OBJECT_STATEMENT:
            return objectStatement != null && !objectStatement.isEmpty();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_IS_DEFINED_BY:
            return rdfsIsDefinedBy != null && !rdfsIsDefinedBy.isEmpty();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDF_VALUE:
            return rdfValue != null && !rdfValue.isEmpty();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_SEE_ALSO:
            return rdfsSeeAlso != null && !rdfsSeeAlso.isEmpty();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDF_TYPE:
            return rdfType != null && !rdfType.isEmpty();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_MEMBER:
            return rdfsMember != null && !rdfsMember.isEmpty();
        case OWLPackage.OWL_OBJECT_PROPERTY__PREDICATE_STATEMENT:
            return predicateStatement != null && !predicateStatement.isEmpty();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_COMMENT:
            return rdfsComment != null && !rdfsComment.isEmpty();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_LABEL:
            return rdfsLabel != null && !rdfsLabel.isEmpty();
        case OWLPackage.OWL_OBJECT_PROPERTY__NAMESPACE:
            return namespace != null;
        case OWLPackage.OWL_OBJECT_PROPERTY__REF_BY_RESTRICTION:
            return refByRestriction != null && !refByRestriction.isEmpty();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_SUB_PROPERTY_OF:
            return rdfsSubPropertyOf != null && !rdfsSubPropertyOf.isEmpty();
        case OWLPackage.OWL_OBJECT_PROPERTY__SUB_PROPERTY:
            return subProperty != null && !subProperty.isEmpty();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_DOMAIN:
            return rdfsDomain != null && !rdfsDomain.isEmpty();
        case OWLPackage.OWL_OBJECT_PROPERTY__RDFS_RANGE:
            return rdfsRange != null && !rdfsRange.isEmpty();
        case OWLPackage.OWL_OBJECT_PROPERTY__DEPRECATED:
            return DEPRECATED_EDEFAULT == null ? deprecated != null
                    : !DEPRECATED_EDEFAULT.equals(deprecated);
        case OWLPackage.OWL_OBJECT_PROPERTY__FUNCTIONAL:
            return FUNCTIONAL_EDEFAULT == null ? functional != null
                    : !FUNCTIONAL_EDEFAULT.equals(functional);
        case OWLPackage.OWL_OBJECT_PROPERTY__OWL_EQUIVALENT_PROPERTY:
            return owlEquivalentProperty != null
                   && !owlEquivalentProperty.isEmpty();
        case OWLPackage.OWL_OBJECT_PROPERTY__INV_OWL_EQUIVALENT_PROPERTY:
            return invOWLEquivalentProperty != null
                   && !invOWLEquivalentProperty.isEmpty();
        case OWLPackage.OWL_OBJECT_PROPERTY__INVERSE_FUNCTIONAL:
            return INVERSE_FUNCTIONAL_EDEFAULT == null ? inverseFunctional != null
                    : !INVERSE_FUNCTIONAL_EDEFAULT.equals(inverseFunctional);
        case OWLPackage.OWL_OBJECT_PROPERTY__SYMMETRIC:
            return SYMMETRIC_EDEFAULT == null ? symmetric != null
                    : !SYMMETRIC_EDEFAULT.equals(symmetric);
        case OWLPackage.OWL_OBJECT_PROPERTY__TRANSITIVE:
            return TRANSITIVE_EDEFAULT == null ? transitive != null
                    : !TRANSITIVE_EDEFAULT.equals(transitive);
        case OWLPackage.OWL_OBJECT_PROPERTY__OWL_INVERSE_OF:
            return owlInverseOf != null;
        case OWLPackage.OWL_OBJECT_PROPERTY__INV_OWL_INVERSE_OF:
            return invOWLInverseOf != null && !invOWLInverseOf.isEmpty();
        }
        return eDynamicIsSet(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public String toString() {
        if (eIsProxy())
            return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (inverseFunctional: ");
        result.append(inverseFunctional);
        result.append(", symmetric: ");
        result.append(symmetric);
        result.append(", transitive: ");
        result.append(transitive);
        result.append(')');
        return result.toString();
    }

} //OWLObjectPropertyImpl
