/**
 * <copyright>
 * </copyright>
 *
 * $Id: PropertyImpl.java,v 1.1.1.1 2006/01/31 09:13:24 gxie Exp $
 */
package org.eclipse.eodm.owl.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.eodm.owl.OWLPackage;
import org.eclipse.eodm.owl.Property;
import org.eclipse.eodm.rdfs.Namespace;
import org.eclipse.eodm.rdfs.impl.RDFPropertyImpl;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Property</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.PropertyImpl#getDeprecated <em>Deprecated</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.PropertyImpl#getFunctional <em>Functional</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.PropertyImpl#getOWLEquivalentProperty <em>OWL Equivalent Property</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.owl.impl.PropertyImpl#getInvOWLEquivalentProperty <em>Inv OWL Equivalent Property</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class PropertyImpl extends RDFPropertyImpl implements Property {
    /**
     * The default value of the '{@link #getDeprecated() <em>Deprecated</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getDeprecated()
     * @generated
     * @ordered
     */
    protected static final Boolean DEPRECATED_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getDeprecated() <em>Deprecated</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getDeprecated()
     * @generated
     * @ordered
     */
    protected Boolean deprecated = DEPRECATED_EDEFAULT;

    /**
     * The default value of the '{@link #getFunctional() <em>Functional</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getFunctional()
     * @generated
     * @ordered
     */
    protected static final Boolean FUNCTIONAL_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getFunctional() <em>Functional</em>}'
     * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getFunctional()
     * @generated
     * @ordered
     */
    protected Boolean functional = FUNCTIONAL_EDEFAULT;

    /**
     * The cached value of the '
     * {@link #getOWLEquivalentProperty() <em>OWL Equivalent Property</em>}'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getOWLEquivalentProperty()
     * @generated
     * @ordered
     */
    protected EList owlEquivalentProperty = null;

    /**
     * The cached value of the '
     * {@link #getInvOWLEquivalentProperty() <em>Inv OWL Equivalent Property</em>}'
     * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getInvOWLEquivalentProperty()
     * @generated
     * @ordered
     */
    protected EList invOWLEquivalentProperty = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected PropertyImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return OWLPackage.eINSTANCE.getProperty();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Boolean getDeprecated() {
        return deprecated;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setDeprecated(Boolean newDeprecated) {
        Boolean oldDeprecated = deprecated;
        deprecated = newDeprecated;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    OWLPackage.PROPERTY__DEPRECATED, oldDeprecated, deprecated));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Boolean getFunctional() {
        return functional;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setFunctional(Boolean newFunctional) {
        Boolean oldFunctional = functional;
        functional = newFunctional;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    OWLPackage.PROPERTY__FUNCTIONAL, oldFunctional, functional));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList getOWLEquivalentProperty() {
        if (owlEquivalentProperty == null) {
            owlEquivalentProperty = new EObjectWithInverseResolvingEList.ManyInverse(
                    Property.class, this,
                    OWLPackage.PROPERTY__OWL_EQUIVALENT_PROPERTY,
                    OWLPackage.PROPERTY__INV_OWL_EQUIVALENT_PROPERTY);
        }
        return owlEquivalentProperty;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList getInvOWLEquivalentProperty() {
        if (invOWLEquivalentProperty == null) {
            invOWLEquivalentProperty = new EObjectWithInverseResolvingEList.ManyInverse(
                    Property.class, this,
                    OWLPackage.PROPERTY__INV_OWL_EQUIVALENT_PROPERTY,
                    OWLPackage.PROPERTY__OWL_EQUIVALENT_PROPERTY);
        }
        return invOWLEquivalentProperty;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd,
            int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case OWLPackage.PROPERTY__SUBJECT_STATEMENT:
                return ((InternalEList) getSubjectStatement()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.PROPERTY__OBJECT_STATEMENT:
                return ((InternalEList) getObjectStatement()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.PROPERTY__RDF_TYPE:
                return ((InternalEList) getRDFType()).basicAdd(otherEnd, msgs);
            case OWLPackage.PROPERTY__PREDICATE_STATEMENT:
                return ((InternalEList) getPredicateStatement()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.PROPERTY__REF_BY_RESTRICTION:
                return ((InternalEList) getRefByRestriction()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.PROPERTY__RDFS_SUB_PROPERTY_OF:
                return ((InternalEList) getRDFSSubPropertyOf()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.PROPERTY__SUB_PROPERTY:
                return ((InternalEList) getSubProperty()).basicAdd(otherEnd,
                        msgs);
            case OWLPackage.PROPERTY__RDFS_DOMAIN:
                return ((InternalEList) getRDFSDomain()).basicAdd(otherEnd,
                        msgs);
            case OWLPackage.PROPERTY__RDFS_RANGE:
                return ((InternalEList) getRDFSRange())
                        .basicAdd(otherEnd, msgs);
            case OWLPackage.PROPERTY__OWL_EQUIVALENT_PROPERTY:
                return ((InternalEList) getOWLEquivalentProperty()).basicAdd(
                        otherEnd, msgs);
            case OWLPackage.PROPERTY__INV_OWL_EQUIVALENT_PROPERTY:
                return ((InternalEList) getInvOWLEquivalentProperty())
                        .basicAdd(otherEnd, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case OWLPackage.PROPERTY__SUBJECT_STATEMENT:
                return ((InternalEList) getSubjectStatement()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.PROPERTY__OBJECT_STATEMENT:
                return ((InternalEList) getObjectStatement()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.PROPERTY__RDF_TYPE:
                return ((InternalEList) getRDFType()).basicRemove(otherEnd,
                        msgs);
            case OWLPackage.PROPERTY__PREDICATE_STATEMENT:
                return ((InternalEList) getPredicateStatement()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.PROPERTY__REF_BY_RESTRICTION:
                return ((InternalEList) getRefByRestriction()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.PROPERTY__RDFS_SUB_PROPERTY_OF:
                return ((InternalEList) getRDFSSubPropertyOf()).basicRemove(
                        otherEnd, msgs);
            case OWLPackage.PROPERTY__SUB_PROPERTY:
                return ((InternalEList) getSubProperty()).basicRemove(otherEnd,
                        msgs);
            case OWLPackage.PROPERTY__RDFS_DOMAIN:
                return ((InternalEList) getRDFSDomain()).basicRemove(otherEnd,
                        msgs);
            case OWLPackage.PROPERTY__RDFS_RANGE:
                return ((InternalEList) getRDFSRange()).basicRemove(otherEnd,
                        msgs);
            case OWLPackage.PROPERTY__OWL_EQUIVALENT_PROPERTY:
                return ((InternalEList) getOWLEquivalentProperty())
                        .basicRemove(otherEnd, msgs);
            case OWLPackage.PROPERTY__INV_OWL_EQUIVALENT_PROPERTY:
                return ((InternalEList) getInvOWLEquivalentProperty())
                        .basicRemove(otherEnd, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass,
                        msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.PROPERTY__LOCAL_NAME:
            return getLocalName();
        case OWLPackage.PROPERTY__URI:
            return getURI();
        case OWLPackage.PROPERTY__SUBJECT_STATEMENT:
            return getSubjectStatement();
        case OWLPackage.PROPERTY__OBJECT_STATEMENT:
            return getObjectStatement();
        case OWLPackage.PROPERTY__RDFS_IS_DEFINED_BY:
            return getRDFSIsDefinedBy();
        case OWLPackage.PROPERTY__RDF_VALUE:
            return getRDFValue();
        case OWLPackage.PROPERTY__RDFS_SEE_ALSO:
            return getRDFSSeeAlso();
        case OWLPackage.PROPERTY__RDF_TYPE:
            return getRDFType();
        case OWLPackage.PROPERTY__RDFS_MEMBER:
            return getRDFSMember();
        case OWLPackage.PROPERTY__PREDICATE_STATEMENT:
            return getPredicateStatement();
        case OWLPackage.PROPERTY__RDFS_COMMENT:
            return getRDFSComment();
        case OWLPackage.PROPERTY__RDFS_LABEL:
            return getRDFSLabel();
        case OWLPackage.PROPERTY__NAMESPACE:
            if (resolve)
                return getNamespace();
            return basicGetNamespace();
        case OWLPackage.PROPERTY__REF_BY_RESTRICTION:
            return getRefByRestriction();
        case OWLPackage.PROPERTY__RDFS_SUB_PROPERTY_OF:
            return getRDFSSubPropertyOf();
        case OWLPackage.PROPERTY__SUB_PROPERTY:
            return getSubProperty();
        case OWLPackage.PROPERTY__RDFS_DOMAIN:
            return getRDFSDomain();
        case OWLPackage.PROPERTY__RDFS_RANGE:
            return getRDFSRange();
        case OWLPackage.PROPERTY__DEPRECATED:
            return getDeprecated();
        case OWLPackage.PROPERTY__FUNCTIONAL:
            return getFunctional();
        case OWLPackage.PROPERTY__OWL_EQUIVALENT_PROPERTY:
            return getOWLEquivalentProperty();
        case OWLPackage.PROPERTY__INV_OWL_EQUIVALENT_PROPERTY:
            return getInvOWLEquivalentProperty();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.PROPERTY__LOCAL_NAME:
            setLocalName((String) newValue);
            return;
        case OWLPackage.PROPERTY__SUBJECT_STATEMENT:
            getSubjectStatement().clear();
            getSubjectStatement().addAll((Collection) newValue);
            return;
        case OWLPackage.PROPERTY__OBJECT_STATEMENT:
            getObjectStatement().clear();
            getObjectStatement().addAll((Collection) newValue);
            return;
        case OWLPackage.PROPERTY__RDFS_IS_DEFINED_BY:
            getRDFSIsDefinedBy().clear();
            getRDFSIsDefinedBy().addAll((Collection) newValue);
            return;
        case OWLPackage.PROPERTY__RDF_VALUE:
            getRDFValue().clear();
            getRDFValue().addAll((Collection) newValue);
            return;
        case OWLPackage.PROPERTY__RDFS_SEE_ALSO:
            getRDFSSeeAlso().clear();
            getRDFSSeeAlso().addAll((Collection) newValue);
            return;
        case OWLPackage.PROPERTY__RDF_TYPE:
            getRDFType().clear();
            getRDFType().addAll((Collection) newValue);
            return;
        case OWLPackage.PROPERTY__RDFS_MEMBER:
            getRDFSMember().clear();
            getRDFSMember().addAll((Collection) newValue);
            return;
        case OWLPackage.PROPERTY__PREDICATE_STATEMENT:
            getPredicateStatement().clear();
            getPredicateStatement().addAll((Collection) newValue);
            return;
        case OWLPackage.PROPERTY__RDFS_COMMENT:
            getRDFSComment().clear();
            getRDFSComment().addAll((Collection) newValue);
            return;
        case OWLPackage.PROPERTY__RDFS_LABEL:
            getRDFSLabel().clear();
            getRDFSLabel().addAll((Collection) newValue);
            return;
        case OWLPackage.PROPERTY__NAMESPACE:
            setNamespace((Namespace) newValue);
            return;
        case OWLPackage.PROPERTY__REF_BY_RESTRICTION:
            getRefByRestriction().clear();
            getRefByRestriction().addAll((Collection) newValue);
            return;
        case OWLPackage.PROPERTY__RDFS_SUB_PROPERTY_OF:
            getRDFSSubPropertyOf().clear();
            getRDFSSubPropertyOf().addAll((Collection) newValue);
            return;
        case OWLPackage.PROPERTY__SUB_PROPERTY:
            getSubProperty().clear();
            getSubProperty().addAll((Collection) newValue);
            return;
        case OWLPackage.PROPERTY__RDFS_DOMAIN:
            getRDFSDomain().clear();
            getRDFSDomain().addAll((Collection) newValue);
            return;
        case OWLPackage.PROPERTY__RDFS_RANGE:
            getRDFSRange().clear();
            getRDFSRange().addAll((Collection) newValue);
            return;
        case OWLPackage.PROPERTY__DEPRECATED:
            setDeprecated((Boolean) newValue);
            return;
        case OWLPackage.PROPERTY__FUNCTIONAL:
            setFunctional((Boolean) newValue);
            return;
        case OWLPackage.PROPERTY__OWL_EQUIVALENT_PROPERTY:
            getOWLEquivalentProperty().clear();
            getOWLEquivalentProperty().addAll((Collection) newValue);
            return;
        case OWLPackage.PROPERTY__INV_OWL_EQUIVALENT_PROPERTY:
            getInvOWLEquivalentProperty().clear();
            getInvOWLEquivalentProperty().addAll((Collection) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.PROPERTY__LOCAL_NAME:
            setLocalName(LOCAL_NAME_EDEFAULT);
            return;
        case OWLPackage.PROPERTY__SUBJECT_STATEMENT:
            getSubjectStatement().clear();
            return;
        case OWLPackage.PROPERTY__OBJECT_STATEMENT:
            getObjectStatement().clear();
            return;
        case OWLPackage.PROPERTY__RDFS_IS_DEFINED_BY:
            getRDFSIsDefinedBy().clear();
            return;
        case OWLPackage.PROPERTY__RDF_VALUE:
            getRDFValue().clear();
            return;
        case OWLPackage.PROPERTY__RDFS_SEE_ALSO:
            getRDFSSeeAlso().clear();
            return;
        case OWLPackage.PROPERTY__RDF_TYPE:
            getRDFType().clear();
            return;
        case OWLPackage.PROPERTY__RDFS_MEMBER:
            getRDFSMember().clear();
            return;
        case OWLPackage.PROPERTY__PREDICATE_STATEMENT:
            getPredicateStatement().clear();
            return;
        case OWLPackage.PROPERTY__RDFS_COMMENT:
            getRDFSComment().clear();
            return;
        case OWLPackage.PROPERTY__RDFS_LABEL:
            getRDFSLabel().clear();
            return;
        case OWLPackage.PROPERTY__NAMESPACE:
            setNamespace((Namespace) null);
            return;
        case OWLPackage.PROPERTY__REF_BY_RESTRICTION:
            getRefByRestriction().clear();
            return;
        case OWLPackage.PROPERTY__RDFS_SUB_PROPERTY_OF:
            getRDFSSubPropertyOf().clear();
            return;
        case OWLPackage.PROPERTY__SUB_PROPERTY:
            getSubProperty().clear();
            return;
        case OWLPackage.PROPERTY__RDFS_DOMAIN:
            getRDFSDomain().clear();
            return;
        case OWLPackage.PROPERTY__RDFS_RANGE:
            getRDFSRange().clear();
            return;
        case OWLPackage.PROPERTY__DEPRECATED:
            setDeprecated(DEPRECATED_EDEFAULT);
            return;
        case OWLPackage.PROPERTY__FUNCTIONAL:
            setFunctional(FUNCTIONAL_EDEFAULT);
            return;
        case OWLPackage.PROPERTY__OWL_EQUIVALENT_PROPERTY:
            getOWLEquivalentProperty().clear();
            return;
        case OWLPackage.PROPERTY__INV_OWL_EQUIVALENT_PROPERTY:
            getInvOWLEquivalentProperty().clear();
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case OWLPackage.PROPERTY__LOCAL_NAME:
            return LOCAL_NAME_EDEFAULT == null ? localName != null
                    : !LOCAL_NAME_EDEFAULT.equals(localName);
        case OWLPackage.PROPERTY__URI:
            return URI_EDEFAULT == null ? getURI() != null : !URI_EDEFAULT
                    .equals(getURI());
        case OWLPackage.PROPERTY__SUBJECT_STATEMENT:
            return subjectStatement != null && !subjectStatement.isEmpty();
        case OWLPackage.PROPERTY__OBJECT_STATEMENT:
            return objectStatement != null && !objectStatement.isEmpty();
        case OWLPackage.PROPERTY__RDFS_IS_DEFINED_BY:
            return rdfsIsDefinedBy != null && !rdfsIsDefinedBy.isEmpty();
        case OWLPackage.PROPERTY__RDF_VALUE:
            return rdfValue != null && !rdfValue.isEmpty();
        case OWLPackage.PROPERTY__RDFS_SEE_ALSO:
            return rdfsSeeAlso != null && !rdfsSeeAlso.isEmpty();
        case OWLPackage.PROPERTY__RDF_TYPE:
            return rdfType != null && !rdfType.isEmpty();
        case OWLPackage.PROPERTY__RDFS_MEMBER:
            return rdfsMember != null && !rdfsMember.isEmpty();
        case OWLPackage.PROPERTY__PREDICATE_STATEMENT:
            return predicateStatement != null && !predicateStatement.isEmpty();
        case OWLPackage.PROPERTY__RDFS_COMMENT:
            return rdfsComment != null && !rdfsComment.isEmpty();
        case OWLPackage.PROPERTY__RDFS_LABEL:
            return rdfsLabel != null && !rdfsLabel.isEmpty();
        case OWLPackage.PROPERTY__NAMESPACE:
            return namespace != null;
        case OWLPackage.PROPERTY__REF_BY_RESTRICTION:
            return refByRestriction != null && !refByRestriction.isEmpty();
        case OWLPackage.PROPERTY__RDFS_SUB_PROPERTY_OF:
            return rdfsSubPropertyOf != null && !rdfsSubPropertyOf.isEmpty();
        case OWLPackage.PROPERTY__SUB_PROPERTY:
            return subProperty != null && !subProperty.isEmpty();
        case OWLPackage.PROPERTY__RDFS_DOMAIN:
            return rdfsDomain != null && !rdfsDomain.isEmpty();
        case OWLPackage.PROPERTY__RDFS_RANGE:
            return rdfsRange != null && !rdfsRange.isEmpty();
        case OWLPackage.PROPERTY__DEPRECATED:
            return DEPRECATED_EDEFAULT == null ? deprecated != null
                    : !DEPRECATED_EDEFAULT.equals(deprecated);
        case OWLPackage.PROPERTY__FUNCTIONAL:
            return FUNCTIONAL_EDEFAULT == null ? functional != null
                    : !FUNCTIONAL_EDEFAULT.equals(functional);
        case OWLPackage.PROPERTY__OWL_EQUIVALENT_PROPERTY:
            return owlEquivalentProperty != null
                   && !owlEquivalentProperty.isEmpty();
        case OWLPackage.PROPERTY__INV_OWL_EQUIVALENT_PROPERTY:
            return invOWLEquivalentProperty != null
                   && !invOWLEquivalentProperty.isEmpty();
        }
        return eDynamicIsSet(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public String toString() {
        if (eIsProxy())
            return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (deprecated: ");
        result.append(deprecated);
        result.append(", functional: ");
        result.append(functional);
        result.append(')');
        return result.toString();
    }

} //PropertyImpl
