/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 * 
 * $Id: AllValuesFromLink.java,v 1.1.1.1 2006/01/31 09:13:26 gxie Exp $
 */

package org.eclipse.eodm.owl.reasoner.structural;

/**
 * AllValuesFromLink TODO Please add comments here.
 */
public class AllValuesFromLink extends NodeLink {
    public AllValuesFromLink(OWLClassClassificationGraph graph) {
        super(graph);
    }

    public AllValuesFromLink(OWLClassClassificationGraph graph, OWLClassNode source,
            OWLClassNode target, int propertyID) {
        super(graph, source, target);
        this.propertyID = propertyID;
    }

    public void setSource(OWLClassNode source) {
        this.source = source;
    }

    public void setTarget(OWLClassNode target) {
        if (this.target != target) {
            if (this.target != null) {
                this.target.allValuesFromByLinks.remove(this);
            }
            this.target = target;
            if (target != null) {
                target.allValuesFromByLinks.add(this);
            }
        }
    }

    public int getPropertyID() {
        return propertyID;
    }

    public void setPropertyID(int propertyID) {
        this.propertyID = propertyID;
    }

    int propertyID;
}
