/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 * 
 * $Id: ReaderTokenizer.java,v 1.1.1.1 2006/01/31 09:13:26 gxie Exp $
 */

package org.eclipse.eodm.owl.reasoner.structural;

import java.io.IOException;
import java.io.Reader;

/**
 * ReaderTokenizer TODO Please add comments here.
 */
public class ReaderTokenizer {
    public ReaderTokenizer(Reader reader) {
        this(reader, " \n\r\t\f");
    }

    public ReaderTokenizer(Reader reader, String delim) {
        if (reader == null || delim == null) {
            throw new NullPointerException();
        }
        this.reader = reader;
        this.delim = delim;
    }

    public String nextToken() throws IOException {
        StringBuffer sb = new StringBuffer();
        boolean flag = false;
        for (;;) {
            int res = reader.read();
            if (res == -1) {
                break;
            }
            if (isDelim((char) res)) {
                if (flag) {
                    break;
                } else {
                    continue;
                }
            } else {
                sb.append((char) res);
                flag = true;
            }
        }
        if (sb.length() == 0) {
            return null;
        } else {
            return sb.toString();
        }
    }

    private boolean isDelim(char ch) {
        return (delim.indexOf(ch) != -1);
    }

    private Reader reader;

    private String delim;
}
