/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 * 
 * $Id: Transposer.java,v 1.1.1.1 2006/01/31 09:13:26 gxie Exp $
 */

package org.eclipse.eodm.owl.reasoner.structural;

import java.util.ArrayList;
import java.util.List;

/**
 * Transposer TODO Please add comments here.
 */
public class Transposer {
    public Transposer(List source, int total) {
        this.source = source;
        this.total = total;
        //        System.out.println("----------Input----------");
        //        ReasonerUtils.showList(source);
        //        System.out.println("----------Input----------");
    }

    private boolean transpose1(int i, int limit, ArrayList current) {
        if (i == source.size()) {
            if (current.size() != limit) {
                System.out.println("Error!?");
            }
            int count = current.size();
            ArrayList newAnswer = new ArrayList();
            IntObject newCounter = new IntObject(0);
            IntObject newSumCounter = new IntObject(0);
            answerCounter.add(newCounter);
            answerSumCounter.add(newSumCounter);
            answer.add(newAnswer);
            for (int j = 0; j < count; j++) {
                int num = ((IntObject) current.get(j)).value;
                newAnswer.add(new Integer(num));
                answerIndex[num].add(newCounter);
                answerSumIndex[num].add(newSumCounter);
            }
            itemCounter[((IntObject) current.get(count - 1)).value]++;
            return true;
        }
        if (((IntObject) sourceCounter.get(i)).value > 0) {
            return transpose1(i + 1, limit, current);
        }
        boolean flag = false;
        List item = (List) source.get(i);
        for (int j = 0; j < item.size(); j++) {
            int num = ((Integer) item.get(j)).intValue();
            if (itemCounter[num] == 0) {
                if (current.size() == limit) {
                    flag = true;
                } else {
                    for (int k = 0; k < sourceIndex[num].size(); k++) {
                        ++((IntObject) sourceIndex[num].get(k)).value;
                    }
                    for (int k = 0; k < answerIndex[num].size(); k++) {
                        if ((--((IntObject) answerIndex[num].get(k)).value) == 1) {
                            itemCounter[((IntObject) answerSumIndex[num].get(k)).value -= num]++;
                        } else {
                            ((IntObject) answerSumIndex[num].get(k)).value -= num;
                        }
                    }
                    current.add(new IntObject(num));
                    flag |= transpose1(i + 1, limit, current);
                    current.remove(current.size() - 1);
                    for (int k = 0; k < answerIndex[num].size(); k++) {
                        if ((((IntObject) answerIndex[num].get(k)).value++) == 1) {
                            itemCounter[((IntObject) answerSumIndex[num].get(k)).value]--;
                        }
                        ((IntObject) answerSumIndex[num].get(k)).value += num;
                    }
                    for (int k = 0; k < sourceIndex[num].size(); k++) {
                        --((IntObject) sourceIndex[num].get(k)).value;
                    }
                }
            }
        }
        return flag;
    }

    public List transpose() {
        sourceIndex = new ArrayList[total];
        answerIndex = new ArrayList[total];
        answerSumIndex = new ArrayList[total];
        for (int i = 0; i < total; i++) {
            sourceIndex[i] = new ArrayList();
            answerIndex[i] = new ArrayList();
            answerSumIndex[i] = new ArrayList();
        }
        for (int i = 0; i < source.size(); i++) {
            for (int j = i + 1; j < source.size(); j++) {
                if (((List) source.get(i)).size() > ((List) source.get(j))
                        .size()) {
                    Object o = source.get(i);
                    source.set(i, source.get(j));
                    source.set(j, o);
                }
            }
        }
        sourceCounter = new ArrayList(source.size());
        answerCounter = new ArrayList();
        answerSumCounter = new ArrayList();
        itemCounter = new int[total];
        for (int i = 0; i < total; i++) {
            itemCounter[i] = 0;
        }
        for (int i = 0; i < source.size(); i++) {
            IntObject counter = new IntObject(0);
            sourceCounter.add(counter);
            List l = (List) source.get(i);
            for (int j = 0; j < l.size(); j++) {
                sourceIndex[((Integer) l.get(j)).intValue()].add(counter);
            }
        }
        answer = new ArrayList();
        ArrayList current = new ArrayList();
        for (int i = 1; i <= total; i++) {
            if (!transpose1(0, i, current)) {
                break;
            }
        }

        //        System.out.println("----------Output----------");
        //        ReasonerUtils.showList(answer);
        //        System.out.println("----------Output----------");
        return answer;
    }

    private List source, answer;

    private ArrayList[] sourceIndex, answerIndex, answerSumIndex;

    private ArrayList sourceCounter, answerCounter, answerSumCounter;

    private int[] itemCounter;

    private int total;
}
