/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 * 
 * $Id: KeyGenerator.java,v 1.1.1.1 2006/01/31 09:13:26 gxie Exp $
 */

package org.eclipse.eodm.owl.resource.parser.impl;

/**
 * KeyGenerator - The Unique Key generation strategy interface.
 * 
 * Unique Key consists of Prefix and Index in common, the strategy is left to be
 * implemented by the OWL Parser's user.
 * <p>
 * The OWL Parser offers a default Blank Node ID generator and a Namespace Name
 * generator.
 * 
 * @see org.eclipse.eodm.owl.resource.parser.impl.BNodeIDGenerator
 * @see org.eclipse.eodm.owl.resource.parser.impl.NSNameGenerator
 *  
 */
public interface KeyGenerator {
    /**
     * Get the next key generated by the generator.
     * 
     * @return the next key
     */
    String getNextKey();
}