/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 * 
 * $Id: OWLURIConstant.java,v 1.1.1.1 2006/01/31 09:13:26 gxie Exp $
 */

package org.eclipse.eodm.owl.resource.parser.impl;

import org.eclipse.eodm.owl.vocabulary.OWL;
import org.eclipse.eodm.rdf.resource.parser.element.URIReference;
import org.eclipse.eodm.rdfs.vocabulary.RDFS;

/**
 * OWLURIConstant
 * 
 */
public class OWLURIConstant {
    /* 1.3 Class URIreferences */
    public static final URIReference ONTOLOGY_URIreference = new URIReference(
            OWL.ONTOLOGY_URI);

    public static final URIReference CLASS_URIreference = new URIReference(
            OWL.CLASS_URI);

    public static final URIReference DEPRECATED_CLASS_URIreference = new URIReference(
            OWL.DEPRECATED_CLASS_URI);

    public static final URIReference RESTRICTION_URIreference = new URIReference(
            OWL.RESTRICTION_URI);

    public static final URIReference OBJECT_PROPERTY_URIreference = new URIReference(
            OWL.OBJECT_PROPERTY_URI);

    public static final URIReference DATATYPE_PROPERTY_URIreference = new URIReference(
            OWL.DATATYPE_PROPERTY_URI);

    public static final URIReference DEPRECATED_PROPERTY_URIreference = new URIReference(
            OWL.DEPRECATED_PROPERTY_URI);

    public static final URIReference FUNCTIONAL_PROPERTY_URIreference = new URIReference(
            OWL.FUNCTIONAL_PROPERTY_URI);

    public static final URIReference INVERSE_FUNCTIONAL_PROPERTY_URIreference = new URIReference(
            OWL.INVERSE_FUNCTIONAL_PROPERTY_URI);

    public static final URIReference SYMMETRIC_PROPERTY_URIreference = new URIReference(
            OWL.SYMMETRIC_PROPERTY_URI);

    public static final URIReference TRANSITIVE_PROPERTY_URIreference = new URIReference(
            OWL.TRANSITIVE_PROPERTY_URI);

    public static final URIReference THING_URIreference = new URIReference(
            OWL.THING_URI);

    public static final URIReference NOTHING_URIreference = new URIReference(
            OWL.NOTHING_URI);

    public static final URIReference ALL_DIFFERENT_URIreference = new URIReference(
            OWL.ALL_DIFFERENT_URI);

    public static final URIReference DATA_RANGE_URIreference = new URIReference(
            OWL.DATA_RANGE_URI);

    public static final URIReference ONTOLOGY_PROPERTY_URIreference = new URIReference(
            OWL.ONTOLOGY_PROPERTY_URI);

    public static final URIReference ANNOTATION_PROPERTY_URIreference = new URIReference(
            OWL.ANNOTATION_PROPERTY_URI);


//    public static final URIReference S_LANG_URI = new URIReference(S_LANG_STR);
//
//    public static final URIReference S_BASE_URI = new URIReference(S_BASE_STR);
//
//    public static final URIReference[] SYNTAX_NAMES = { S_LANG_URI, S_BASE_URI };

    /* 2.3 Property URIreferences */
    public static final URIReference ONE_OF_URIreference = new URIReference(
            OWL.ONE_OF_URI);

    public static final URIReference SAME_AS_URIreference = new URIReference(
            OWL.SAME_AS_URI);

    public static final URIReference ON_PROPERTY_URIreference = new URIReference(
            OWL.ON_PROPERTY_URI);

    public static final URIReference HAS_VALUE_URIreference = new URIReference(
            OWL.HAS_VALUE_URI);

    public static final URIReference ALL_VALUES_FROM_URIreference = new URIReference(
            OWL.ALL_VALUES_FROM_URI);

    public static final URIReference SOME_VALUES_FROM_URIreference = new URIReference(
            OWL.SOME_VALUES_FROM_URI);

    public static final URIReference CARDINALITY_URIreference = new URIReference(
            OWL.CARDINALITY_URI);

    public static final URIReference MAX_CARDINALITY_URIreference = new URIReference(
            OWL.MAX_CARDINALITY_URI);

    public static final URIReference MIN_CARDINALITY_URIreference = new URIReference(
            OWL.MIN_CARDINALITY_URI);

    public static final URIReference INTERSECTION_OF_URIreference = new URIReference(
            OWL.INTERSECTION_OF_URI);

    public static final URIReference UNION_OF_URIreference = new URIReference(
            OWL.UNION_OF_URI);

    public static final URIReference COMPLEMENT_OF_URIreference = new URIReference(
            OWL.COMPLEMENT_OF_URI);

    public static final URIReference EQUIVALENT_CLASS_URIreference = new URIReference(
            OWL.EQUIVALENT_CLASS_URI);
    
    public static final URIReference SUBCLASSOF_URIreference = new URIReference(
            RDFS.P_SUBCLASSOF_STR);

    public static final URIReference EQUIVALENT_PROPERTY_URIreference = new URIReference(
            OWL.EQUIVALENT_PROPERTY_URI);

    public static final URIReference INVERSE_OF_URIreference = new URIReference(
            OWL.INVERSE_OF_URI);

    public static final URIReference DISJOINT_WITH_URIreference = new URIReference(
            OWL.DISJOINT_WITH_URI);

    public static final URIReference DIFFERENT_FROM_URIreference = new URIReference(
            OWL.DIFFERENT_FROM_URI);

    public static final URIReference DISTINCT_MEMBERS_URIreference = new URIReference(
            OWL.DISTINCT_MEMBERS_URI);

    public static final URIReference IMPORTS_URIreference = new URIReference(
            OWL.IMPORTS_URI);

    public static final URIReference VERSION_INFO_URIreference = new URIReference(
            OWL.VERSION_INFO_URI);

    public static final URIReference PRIOR_VERSION_URIreference = new URIReference(
            OWL.PRIOR_VERSION_URI);

    public static final URIReference BACKWARD_COMPATIBLE_WITH_URIreference = new URIReference(
            OWL.BACKWARD_COMPATIBLE_WITH_URI);

    public static final URIReference INCOMPATIBLE_WITH_URIreference = new URIReference(
            OWL.INCOMPATIBLE_WITH_URI);

}
