/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 * 
 * $Id: RDFNamespaceMap.java,v 1.1.1.1 2006/01/31 09:13:26 gxie Exp $
 */

package org.eclipse.eodm.rdf.resource.parser.wrapper;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.eodm.rdfs.Namespace;

/**
 * RDFNamespaceMap
 */
public class RDFNamespaceMap {
    private static final String nsPrefix = "ns_";

    private static int nsIndex = 0;

    private Map namespaces = new HashMap();
    
    public String getKey(){
        return (nsPrefix+(nsIndex++));
    }

    public void addNamespace(Namespace namespace) {
        if (namespace.getName() == null || namespace.getName() == "")
            namespace.setName(nsPrefix + nsIndex++);
        namespaces.put(namespace.getURI(), namespace);
    }

    public void addNamespace(String uri, Namespace namespace) {
        if (namespace.getName() == null || namespace.getName() == "")
            namespace.setName(nsPrefix + nsIndex++);
        namespaces.put(uri, namespace);
    }

    public Namespace getNamespace(String uri) {
        return (Namespace) namespaces.get(uri);
    }

    public Namespace removeNamespace(String uri) {
        return (Namespace) namespaces.remove(uri);
    }

    public void removeAllNamespaces() {
        namespaces.clear();
    }
}