/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: RDFList.java,v 1.1.1.1 2006/01/31 09:13:24 gxie Exp $
 */
package org.eclipse.eodm.rdfs;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>RDF List</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link org.eclipse.eodm.rdfs.RDFList#getRDFRest <em>RDF Rest</em>}</li>
 * <li>{@link org.eclipse.eodm.rdfs.RDFList#getRDFFirst <em>RDF First</em>}</li>
 * </ul>
 * </p>
 * 
 * @see org.eclipse.eodm.rdfs.RDFSPackage#getRDFList()
 * @model
 * @generated
 */
public interface RDFList extends RDFSResource {
    /**
     * Returns the value of the '<em><b>RDF Rest</b></em>' reference. <!--
     * begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>RDF Rest</em>' reference.
     * @see #setRDFRest(RDFList)
     * @see org.eclipse.eodm.rdfs.RDFSPackage#getRDFList_RDFRest()
     * @model
     * @generated
     */
    RDFList getRDFRest();

    /**
     * Sets the value of the '
     * {@link org.eclipse.eodm.rdfs.RDFList#getRDFRest <em>RDF Rest</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value
     *            the new value of the '<em>RDF Rest</em>' reference.
     * @see #getRDFRest()
     * @generated
     */
    void setRDFRest(RDFList value);

    /**
     * Returns the value of the '<em><b>RDF First</b></em>' reference. <!--
     * begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>RDF First</em>' reference.
     * @see #setRDFFirst(RDFSResource)
     * @see org.eclipse.eodm.rdfs.RDFSPackage#getRDFList_RDFFirst()
     * @model
     * @generated
     */
    RDFSResource getRDFFirst();

    /**
     * Sets the value of the '
     * {@link org.eclipse.eodm.rdfs.RDFList#getRDFFirst <em>RDF First</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @param value
     *            the new value of the '<em>RDF First</em>' reference.
     * @see #getRDFFirst()
     * @generated
     */
    void setRDFFirst(RDFSResource value);

} // RDFList
