/**
 * <copyright> 
 * 
 * Copyright (c) 2004-2005 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License - v 1.0 
 * which accompanies this distribution, and is available at 
 * http://opensource.org/licenses/eclipse-1.0.txt 
 * 
 * Contributors: 
 *   IBM - Initial API and implementation 
 * 
 * </copyright> 
 *
 * $Id: RDFStatementImpl.java,v 1.1.1.1 2006/01/31 09:13:25 gxie Exp $
 */
package org.eclipse.eodm.rdfs.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.eodm.rdfs.Namespace;
import org.eclipse.eodm.rdfs.RDFSPackage;
import org.eclipse.eodm.rdfs.RDFSResource;
import org.eclipse.eodm.rdfs.RDFStatement;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>RDF Statement</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link org.eclipse.eodm.rdfs.impl.RDFStatementImpl#getRDFSubject <em>RDF Subject</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.rdfs.impl.RDFStatementImpl#getRDFObject <em>RDF Object</em>}
 * </li>
 * <li>
 * {@link org.eclipse.eodm.rdfs.impl.RDFStatementImpl#getRDFPredicate <em>RDF Predicate</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class RDFStatementImpl extends RDFSResourceImpl implements RDFStatement {
    /**
     * The cached value of the '{@link #getRDFSubject() <em>RDF Subject</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getRDFSubject()
     * @generated
     * @ordered
     */
    protected RDFSResource rdfSubject = null;

    /**
     * The cached value of the '{@link #getRDFObject() <em>RDF Object</em>}'
     * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getRDFObject()
     * @generated
     * @ordered
     */
    protected RDFSResource rdfObject = null;

    /**
     * The cached value of the '
     * {@link #getRDFPredicate() <em>RDF Predicate</em>}' reference. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getRDFPredicate()
     * @generated
     * @ordered
     */
    protected RDFSResource rdfPredicate = null;

    /**
     * Comment for <code>isReified</code>
     * 
     * A flag to decide whether a reified statement, or just an ordinary triple
     */
    protected boolean isReified = false;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected RDFStatementImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return RDFSPackage.eINSTANCE.getRDFStatement();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public RDFSResource getRDFSubject() {
        if (rdfSubject != null && rdfSubject.eIsProxy()) {
            RDFSResource oldRDFSubject = rdfSubject;
            rdfSubject = (RDFSResource) eResolveProxy((InternalEObject) rdfSubject);
            if (rdfSubject != oldRDFSubject) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE,
                            RDFSPackage.RDFS_TATEMENT__RDF_SUBJECT,
                            oldRDFSubject, rdfSubject));
            }
        }
        return rdfSubject;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public RDFSResource basicGetRDFSubject() {
        return rdfSubject;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetRDFSubject(RDFSResource newRDFSubject,
            NotificationChain msgs) {
        RDFSResource oldRDFSubject = rdfSubject;
        rdfSubject = newRDFSubject;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this,
                    Notification.SET, RDFSPackage.RDFS_TATEMENT__RDF_SUBJECT,
                    oldRDFSubject, newRDFSubject);
            if (msgs == null)
                msgs = notification;
            else
                msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setRDFSubject(RDFSResource newRDFSubject) {
        if (newRDFSubject != rdfSubject) {
            NotificationChain msgs = null;
            if (rdfSubject != null)
                msgs = ((InternalEObject) rdfSubject).eInverseRemove(this,
                        RDFSPackage.RDFS_RESOURCE__SUBJECT_STATEMENT,
                        RDFSResource.class, msgs);
            if (newRDFSubject != null)
                msgs = ((InternalEObject) newRDFSubject).eInverseAdd(this,
                        RDFSPackage.RDFS_RESOURCE__SUBJECT_STATEMENT,
                        RDFSResource.class, msgs);
            msgs = basicSetRDFSubject(newRDFSubject, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    RDFSPackage.RDFS_TATEMENT__RDF_SUBJECT, newRDFSubject,
                    newRDFSubject));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public RDFSResource getRDFObject() {
        if (rdfObject != null && rdfObject.eIsProxy()) {
            RDFSResource oldRDFObject = rdfObject;
            rdfObject = (RDFSResource) eResolveProxy((InternalEObject) rdfObject);
            if (rdfObject != oldRDFObject) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE,
                            RDFSPackage.RDFS_TATEMENT__RDF_OBJECT,
                            oldRDFObject, rdfObject));
            }
        }
        return rdfObject;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public RDFSResource basicGetRDFObject() {
        return rdfObject;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetRDFObject(RDFSResource newRDFObject,
            NotificationChain msgs) {
        RDFSResource oldRDFObject = rdfObject;
        rdfObject = newRDFObject;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this,
                    Notification.SET, RDFSPackage.RDFS_TATEMENT__RDF_OBJECT,
                    oldRDFObject, newRDFObject);
            if (msgs == null)
                msgs = notification;
            else
                msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setRDFObject(RDFSResource newRDFObject) {
        if (newRDFObject != rdfObject) {
            NotificationChain msgs = null;
            if (rdfObject != null)
                msgs = ((InternalEObject) rdfObject).eInverseRemove(this,
                        RDFSPackage.RDFS_RESOURCE__OBJECT_STATEMENT,
                        RDFSResource.class, msgs);
            if (newRDFObject != null)
                msgs = ((InternalEObject) newRDFObject).eInverseAdd(this,
                        RDFSPackage.RDFS_RESOURCE__OBJECT_STATEMENT,
                        RDFSResource.class, msgs);
            msgs = basicSetRDFObject(newRDFObject, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    RDFSPackage.RDFS_TATEMENT__RDF_OBJECT, newRDFObject,
                    newRDFObject));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public RDFSResource getRDFPredicate() {
        if (rdfPredicate != null && rdfPredicate.eIsProxy()) {
            RDFSResource oldRDFPredicate = rdfPredicate;
            rdfPredicate = (RDFSResource) eResolveProxy((InternalEObject) rdfPredicate);
            if (rdfPredicate != oldRDFPredicate) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE,
                            RDFSPackage.RDFS_TATEMENT__RDF_PREDICATE,
                            oldRDFPredicate, rdfPredicate));
            }
        }
        return rdfPredicate;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public RDFSResource basicGetRDFPredicate() {
        return rdfPredicate;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetRDFPredicate(RDFSResource newRDFPredicate,
            NotificationChain msgs) {
        RDFSResource oldRDFPredicate = rdfPredicate;
        rdfPredicate = newRDFPredicate;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this,
                    Notification.SET, RDFSPackage.RDFS_TATEMENT__RDF_PREDICATE,
                    oldRDFPredicate, newRDFPredicate);
            if (msgs == null)
                msgs = notification;
            else
                msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setRDFPredicate(RDFSResource newRDFPredicate) {
        if (newRDFPredicate != rdfPredicate) {
            NotificationChain msgs = null;
            if (rdfPredicate != null)
                msgs = ((InternalEObject) rdfPredicate).eInverseRemove(this,
                        RDFSPackage.RDFS_RESOURCE__PREDICATE_STATEMENT,
                        RDFSResource.class, msgs);
            if (newRDFPredicate != null)
                msgs = ((InternalEObject) newRDFPredicate).eInverseAdd(this,
                        RDFSPackage.RDFS_RESOURCE__PREDICATE_STATEMENT,
                        RDFSResource.class, msgs);
            msgs = basicSetRDFPredicate(newRDFPredicate, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    RDFSPackage.RDFS_TATEMENT__RDF_PREDICATE, newRDFPredicate,
                    newRDFPredicate));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd,
            int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case RDFSPackage.RDFS_TATEMENT__SUBJECT_STATEMENT:
                return ((InternalEList) getSubjectStatement()).basicAdd(
                        otherEnd, msgs);
            case RDFSPackage.RDFS_TATEMENT__OBJECT_STATEMENT:
                return ((InternalEList) getObjectStatement()).basicAdd(
                        otherEnd, msgs);
            case RDFSPackage.RDFS_TATEMENT__RDF_TYPE:
                return ((InternalEList) getRDFType()).basicAdd(otherEnd, msgs);
            case RDFSPackage.RDFS_TATEMENT__PREDICATE_STATEMENT:
                return ((InternalEList) getPredicateStatement()).basicAdd(
                        otherEnd, msgs);
            case RDFSPackage.RDFS_TATEMENT__RDF_SUBJECT:
                if (rdfSubject != null)
                    msgs = ((InternalEObject) rdfSubject).eInverseRemove(this,
                            RDFSPackage.RDFS_RESOURCE__SUBJECT_STATEMENT,
                            RDFSResource.class, msgs);
                return basicSetRDFSubject((RDFSResource) otherEnd, msgs);
            case RDFSPackage.RDFS_TATEMENT__RDF_OBJECT:
                if (rdfObject != null)
                    msgs = ((InternalEObject) rdfObject).eInverseRemove(this,
                            RDFSPackage.RDFS_RESOURCE__OBJECT_STATEMENT,
                            RDFSResource.class, msgs);
                return basicSetRDFObject((RDFSResource) otherEnd, msgs);
            case RDFSPackage.RDFS_TATEMENT__RDF_PREDICATE:
                if (rdfPredicate != null)
                    msgs = ((InternalEObject) rdfPredicate).eInverseRemove(
                            this,
                            RDFSPackage.RDFS_RESOURCE__PREDICATE_STATEMENT,
                            RDFSResource.class, msgs);
                return basicSetRDFPredicate((RDFSResource) otherEnd, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd,
            int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case RDFSPackage.RDFS_TATEMENT__SUBJECT_STATEMENT:
                return ((InternalEList) getSubjectStatement()).basicRemove(
                        otherEnd, msgs);
            case RDFSPackage.RDFS_TATEMENT__OBJECT_STATEMENT:
                return ((InternalEList) getObjectStatement()).basicRemove(
                        otherEnd, msgs);
            case RDFSPackage.RDFS_TATEMENT__RDF_TYPE:
                return ((InternalEList) getRDFType()).basicRemove(otherEnd,
                        msgs);
            case RDFSPackage.RDFS_TATEMENT__PREDICATE_STATEMENT:
                return ((InternalEList) getPredicateStatement()).basicRemove(
                        otherEnd, msgs);
            case RDFSPackage.RDFS_TATEMENT__RDF_SUBJECT:
                return basicSetRDFSubject(null, msgs);
            case RDFSPackage.RDFS_TATEMENT__RDF_OBJECT:
                return basicSetRDFObject(null, msgs);
            case RDFSPackage.RDFS_TATEMENT__RDF_PREDICATE:
                return basicSetRDFPredicate(null, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass,
                        msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case RDFSPackage.RDFS_TATEMENT__LOCAL_NAME:
            return getLocalName();
        case RDFSPackage.RDFS_TATEMENT__URI:
            return getURI();
        case RDFSPackage.RDFS_TATEMENT__SUBJECT_STATEMENT:
            return getSubjectStatement();
        case RDFSPackage.RDFS_TATEMENT__OBJECT_STATEMENT:
            return getObjectStatement();
        case RDFSPackage.RDFS_TATEMENT__RDFS_IS_DEFINED_BY:
            return getRDFSIsDefinedBy();
        case RDFSPackage.RDFS_TATEMENT__RDF_VALUE:
            return getRDFValue();
        case RDFSPackage.RDFS_TATEMENT__RDFS_SEE_ALSO:
            return getRDFSSeeAlso();
        case RDFSPackage.RDFS_TATEMENT__RDF_TYPE:
            return getRDFType();
        case RDFSPackage.RDFS_TATEMENT__RDFS_MEMBER:
            return getRDFSMember();
        case RDFSPackage.RDFS_TATEMENT__PREDICATE_STATEMENT:
            return getPredicateStatement();
        case RDFSPackage.RDFS_TATEMENT__RDFS_COMMENT:
            return getRDFSComment();
        case RDFSPackage.RDFS_TATEMENT__RDFS_LABEL:
            return getRDFSLabel();
        case RDFSPackage.RDFS_TATEMENT__NAMESPACE:
            if (resolve)
                return getNamespace();
            return basicGetNamespace();
        case RDFSPackage.RDFS_TATEMENT__RDF_SUBJECT:
            if (resolve)
                return getRDFSubject();
            return basicGetRDFSubject();
        case RDFSPackage.RDFS_TATEMENT__RDF_OBJECT:
            if (resolve)
                return getRDFObject();
            return basicGetRDFObject();
        case RDFSPackage.RDFS_TATEMENT__RDF_PREDICATE:
            if (resolve)
                return getRDFPredicate();
            return basicGetRDFPredicate();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case RDFSPackage.RDFS_TATEMENT__LOCAL_NAME:
            setLocalName((String) newValue);
            return;
        case RDFSPackage.RDFS_TATEMENT__SUBJECT_STATEMENT:
            getSubjectStatement().clear();
            getSubjectStatement().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDFS_TATEMENT__OBJECT_STATEMENT:
            getObjectStatement().clear();
            getObjectStatement().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDFS_TATEMENT__RDFS_IS_DEFINED_BY:
            getRDFSIsDefinedBy().clear();
            getRDFSIsDefinedBy().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDFS_TATEMENT__RDF_VALUE:
            getRDFValue().clear();
            getRDFValue().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDFS_TATEMENT__RDFS_SEE_ALSO:
            getRDFSSeeAlso().clear();
            getRDFSSeeAlso().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDFS_TATEMENT__RDF_TYPE:
            getRDFType().clear();
            getRDFType().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDFS_TATEMENT__RDFS_MEMBER:
            getRDFSMember().clear();
            getRDFSMember().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDFS_TATEMENT__PREDICATE_STATEMENT:
            getPredicateStatement().clear();
            getPredicateStatement().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDFS_TATEMENT__RDFS_COMMENT:
            getRDFSComment().clear();
            getRDFSComment().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDFS_TATEMENT__RDFS_LABEL:
            getRDFSLabel().clear();
            getRDFSLabel().addAll((Collection) newValue);
            return;
        case RDFSPackage.RDFS_TATEMENT__NAMESPACE:
            setNamespace((Namespace) newValue);
            return;
        case RDFSPackage.RDFS_TATEMENT__RDF_SUBJECT:
            setRDFSubject((RDFSResource) newValue);
            return;
        case RDFSPackage.RDFS_TATEMENT__RDF_OBJECT:
            setRDFObject((RDFSResource) newValue);
            return;
        case RDFSPackage.RDFS_TATEMENT__RDF_PREDICATE:
            setRDFPredicate((RDFSResource) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case RDFSPackage.RDFS_TATEMENT__LOCAL_NAME:
            setLocalName(LOCAL_NAME_EDEFAULT);
            return;
        case RDFSPackage.RDFS_TATEMENT__SUBJECT_STATEMENT:
            getSubjectStatement().clear();
            return;
        case RDFSPackage.RDFS_TATEMENT__OBJECT_STATEMENT:
            getObjectStatement().clear();
            return;
        case RDFSPackage.RDFS_TATEMENT__RDFS_IS_DEFINED_BY:
            getRDFSIsDefinedBy().clear();
            return;
        case RDFSPackage.RDFS_TATEMENT__RDF_VALUE:
            getRDFValue().clear();
            return;
        case RDFSPackage.RDFS_TATEMENT__RDFS_SEE_ALSO:
            getRDFSSeeAlso().clear();
            return;
        case RDFSPackage.RDFS_TATEMENT__RDF_TYPE:
            getRDFType().clear();
            return;
        case RDFSPackage.RDFS_TATEMENT__RDFS_MEMBER:
            getRDFSMember().clear();
            return;
        case RDFSPackage.RDFS_TATEMENT__PREDICATE_STATEMENT:
            getPredicateStatement().clear();
            return;
        case RDFSPackage.RDFS_TATEMENT__RDFS_COMMENT:
            getRDFSComment().clear();
            return;
        case RDFSPackage.RDFS_TATEMENT__RDFS_LABEL:
            getRDFSLabel().clear();
            return;
        case RDFSPackage.RDFS_TATEMENT__NAMESPACE:
            setNamespace((Namespace) null);
            return;
        case RDFSPackage.RDFS_TATEMENT__RDF_SUBJECT:
            setRDFSubject((RDFSResource) null);
            return;
        case RDFSPackage.RDFS_TATEMENT__RDF_OBJECT:
            setRDFObject((RDFSResource) null);
            return;
        case RDFSPackage.RDFS_TATEMENT__RDF_PREDICATE:
            setRDFPredicate((RDFSResource) null);
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case RDFSPackage.RDFS_TATEMENT__LOCAL_NAME:
            return LOCAL_NAME_EDEFAULT == null ? localName != null
                    : !LOCAL_NAME_EDEFAULT.equals(localName);
        case RDFSPackage.RDFS_TATEMENT__URI:
            return URI_EDEFAULT == null ? getURI() != null : !URI_EDEFAULT
                    .equals(getURI());
        case RDFSPackage.RDFS_TATEMENT__SUBJECT_STATEMENT:
            return subjectStatement != null && !subjectStatement.isEmpty();
        case RDFSPackage.RDFS_TATEMENT__OBJECT_STATEMENT:
            return objectStatement != null && !objectStatement.isEmpty();
        case RDFSPackage.RDFS_TATEMENT__RDFS_IS_DEFINED_BY:
            return rdfsIsDefinedBy != null && !rdfsIsDefinedBy.isEmpty();
        case RDFSPackage.RDFS_TATEMENT__RDF_VALUE:
            return rdfValue != null && !rdfValue.isEmpty();
        case RDFSPackage.RDFS_TATEMENT__RDFS_SEE_ALSO:
            return rdfsSeeAlso != null && !rdfsSeeAlso.isEmpty();
        case RDFSPackage.RDFS_TATEMENT__RDF_TYPE:
            return rdfType != null && !rdfType.isEmpty();
        case RDFSPackage.RDFS_TATEMENT__RDFS_MEMBER:
            return rdfsMember != null && !rdfsMember.isEmpty();
        case RDFSPackage.RDFS_TATEMENT__PREDICATE_STATEMENT:
            return predicateStatement != null && !predicateStatement.isEmpty();
        case RDFSPackage.RDFS_TATEMENT__RDFS_COMMENT:
            return rdfsComment != null && !rdfsComment.isEmpty();
        case RDFSPackage.RDFS_TATEMENT__RDFS_LABEL:
            return rdfsLabel != null && !rdfsLabel.isEmpty();
        case RDFSPackage.RDFS_TATEMENT__NAMESPACE:
            return namespace != null;
        case RDFSPackage.RDFS_TATEMENT__RDF_SUBJECT:
            return rdfSubject != null;
        case RDFSPackage.RDFS_TATEMENT__RDF_OBJECT:
            return rdfObject != null;
        case RDFSPackage.RDFS_TATEMENT__RDF_PREDICATE:
            return rdfPredicate != null;
        }
        return eDynamicIsSet(eFeature);
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.rdfs.RDFStatement#isReified()
     */
    public boolean isReified() {
        return isReified;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.rdfs.RDFStatement#setReified(boolean)
     */
    public void setReified(boolean value) {
        isReified = value;
    }
} //RDFStatementImpl
